
#include <stdio.h>
#include <stdlib.h>
#include<fstream.h>
#include <windows.h>		// Header File For Windows
//#include <gl\gl.h>			// Header File For The OpenGL32 Library
//#include <gl\glu.h>			// Header File For The GLu32 Library
//#include <gl\glaux.h>		// Header File For The Glaux Library

//#include <GL\glut.h>
#include <gl\glut.h>
#include <gl\GLAux.h>
#include <math.h>

#pragma comment( lib, "opengl32.lib" )								// Search For OpenGL32.lib While Linking ( NEW )
#pragma comment( lib, "glu32.lib" )									// Search For GLu32.lib While Linking    ( NEW )
#pragma comment( lib, "glaux.lib" )									// Search For GLaux.lib While Linking    ( NEW )

#include "coldet.h"
#include "MilkshapeModel.h"

#include "XYZ.h"
#include "shot.h"
#include "camera.h"
#include "player.h"
#include "terrain_list.h"
#include "message.h"
#include "monster.h"
#include "explosion.h"
#include "level.h"



HDC			hDC=NULL;		// Private GDI Device Context
HGLRC		hRC=NULL;		// Permanent Rendering Context
HWND		hWnd=NULL;		// Holds Our Window Handle
HINSTANCE	hInstance;		// Holds The Instance Of The Application

#define MOUSE_LEFT		256
#define MOUSE_MIDDLE	257
#define MOUSE_RIGHT		258

#define FIRE_1			0
#define FIRE_2			1
#define ACC_PLUS		2
#define ACC_MINUS		3
#define PAUSE			4
#define LEVEL_JUMP		5
#define GOD_MODE		6
#define STRAFE_L		7
#define STRAFE_R		8
#define STRAFE_U		9
#define STRAFE_D		10

const int num_bindings=11;
int binding[num_bindings];

bool fire_1_active = false;
bool fire_2_active = false;


float FOV_mod = 1;
float FOV_max = 170;

//Fog
GLuint filter;
GLuint fog_mode[]= { GL_EXP, GL_EXP2, GL_LINEAR };
GLuint fog_filter= 0;
GLfloat fog_color[4]= {0.5f, 0.5f, 0.5f, 1.0f};
GLfloat fog_density = 0.0003;
bool do_fog;


//Lighting
float light_ambient[8][4];			//Ambient parameters of lights
float light_diffuse[8][4];			//Diffuse parameters of lights
float light_specular[8][4];			//Specular parameters of lights
float light_position[8][3];			//Position of lights
float empty_light[4];				//Parameter of blank light

float ship_diffuse[4];
float main_diffuse[4];
float main_light_pos[8][4];
float origin_light[4];

bool show_light = false;

//Materials
float material_ambient[20][4];		//Ambient parameters of material
float material_diffuse[6][4];		//Diffuse parameters of material
float material_specular[6][4];		//Specular parameters of material
float material_shininess[6];		//Snininess of material


//Set kinds
#define SET_VALLEY		0
#define SET_SPACE		1
#define SET_METAL		2
#define SET_CAVE		3
//etc

//Piece types
#define T_START			0
#define T_END			1
#define T_NORMAL		2
//etc

const int num_types = 3;
XYZ offset;


POINT *cursor_position=new POINT;

bool	keys[259];			// Array Used For The Keyboard Routine
bool	click[3];
bool	active=TRUE;		// Window Active Flag Set To TRUE By Default
bool	fullscreen=TRUE;	// Fullscreen Flag Set To Fullscreen Mode By Default
MSG		msg;									// Windows Message Structure
BOOL	done=FALSE;								// Bool Variable To Exit Loop

#define pi 3.141592654	//Pi - what else could it be?

int SCREEN_X = 1024;
int SCREEN_Y = 768;
int SCREEN_X_MID = SCREEN_X/2;
int SCREEN_Y_MID = SCREEN_Y/2;
int rx = 1024;
int ry = 768;

char err[512];
ofstream err_log;

double rad_pi=180/pi;
double pi_rad=pi/180;

bool paused = false;

//Models
Model *model_ship = NULL;
Model *model_monster1 = NULL;
Model *model_monster2 = NULL;
Model *model_monster3 = NULL;
Model *model_monster4 = NULL;
Model *model_monster5 = NULL;
Model *model_shot1 = NULL;
Model *model_shot2 = NULL;
Model *model_shot3 = NULL;
Model *model_shot4 = NULL;
Model *model_explosion = NULL;


//Textures
GLuint		texture[7];
bool init_textures = true;
bool polygonal_walls = true;

int texture_number=0;
int texture_list[16];

//Time
double time1;						//Time variables
double time2;
double time_total;
double time_difference;
double time_factor;
double time_factor_denom=10;
double overall_time=0;
double min_start_time = 1000;

bool first_run = true;

double start_pos_x=0;
double start_pos_y=0;
double start_pos_z=500;
double start_vel_x=1;
double start_vel_y=0;
double start_vel_z=.1;
double start_theta=0;
double start_phi=0;

bool draw_off=false;

//Shots
const int max_shots=100;
shot shots[max_shots];
int num_shots=0;
int shot_life = 400;
float shot_speeds[30];
float shot_strengths[30];
float shot_size[30];
float shot_color[30][3];
float shot_scale_factor=500;

//Player
player ship;
int ship_size = 25;
int ship_size2 = ship_size/2;
XYZ ship_dir;
float shield_recharge = .3;
float shield_spin_max = 100;
float wall_damage = 20;
int starting_lives = 5;
int lives = starting_lives;
long score = 0;
long level_score = 0;
bool won = false;
bool god_mode = false;
float banking_factor = 1.5;		//0 -> no banking | 1+ ->strong banking
XYZ player_start;


//Camera
camera cam;
bool left_button=false;
bool right_button=false;
double FOV_init = 90;
double FOV=FOV_init;
double mouse_sensitivity=.2;
double mouse_sensitivity_x=mouse_sensitivity;
double mouse_sensitivity_y=mouse_sensitivity;
double camera_move_speed=.3;
bool show_cursor=true;
XYZ ship_offset;
XYZ ship_base_offset;

//Terrain
terrain_list terrain;
int current_id = 0;
int current_set = SET_METAL;
int current_piece = 0;
int max_string_length = 1024;
char *terrain_string = (char*)calloc(max_string_length,sizeof(char));
int terrain_length = 0;
int num_shown_terrain = 20;	// Min 2 / Max 20

double straight_length = 2000;
double turn_length = 500;
double sharp_turn_length = 1000;
double piece_width = 1000;
double piece_width2 = piece_width/2;
double piece_height = 1000;
double piece_height2 = piece_height/2;
double noise = 250;	//250
double noise_offset = 0;	//-125

float cs_noises[16];
float cs_offsets[16];

XYZ cs[16];					//Current cross section of piece
int cs_verts=0;

double view_distance = (num_shown_terrain-1)*straight_length;


//Collision stuff
bool rebuild_walls = false;
bool first_walls = true;
bool walls_done = false;
float bounding_box[8][3];
CollisionModel3D *ship_model = newCollisionModel3D();
CollisionModel3D *walls1_model = newCollisionModel3D();
CollisionModel3D *walls2_model = newCollisionModel3D();
float ship_mat[16];
float walls1_mat[16];
float walls2_mat[16];
float empty_mat[16];
float ray1_mat[16];
float ray2_mat[16];
float cam_mat[16];
float ray_origin[3];
float ray_dir[3];

XYZ repulsion;
XYZ normal, U, V;
float repulsion_amt = 10;	//Amount of repulsion force
float repulsion_red = .3;	//Amount of force to be lost each iteration
float ray_multiplier = 2.5;	//Multiplied into repulsion_amt if outside cross section
float distance;
float repulsion_theta;
float repulsion_phi;
float repulsion_mag;

float origin[3] = {0.0f, 0.0f, 0.0f};
float cam_origin[3];
float cam_size = 50;

//May not need the cam repulsion vars
XYZ cam_repulsion;
float cam_repulsion_amt = 20;
float cam_repulsion_red = 1;
float cam_repulsion_phi;
float cam_repulsion_mag = 0;

float offset_factor = .08;

//Monsters
int num_monsters;
const int max_num_monsters = 512;
monster monsters[max_num_monsters];
int current_monster_id = 0;
float turn_tolerance = .1;		// .05
XYZ goal_force;
XYZ repulsion_force;
XYZ repulsion_dir;
float goal_weight = 1.5;			// .5
float repulsion_weight = .5;	// .1 ?
XYZ force;
float lead_factor;
float lead_numerator = 30000;		//I refuse to explain these ones
float lead_bits = 6000;				//Suffice to say, they control monster leading (I need to redo it eventually)
float min_shooting_distance = 1000;
float monster_target[3];

float shot_helper_factor = 1;		//1.2
float shot_helper = shot_helper_factor*shot_helper_factor;
float defense_helper_factor = 1;	//0.8
float defense_helper = defense_helper_factor*defense_helper_factor;

//Explosions
const int max_num_explosions = 256;
explosion explosions[max_num_explosions];
float explosive_helper = 20;


//Levels
const int num_levels = 4;
level levels[num_levels];
int current_level = 0;
bool advancing_level = false;
bool got_dead = false;

//Messages
message messages;
char *temp_message = (char*)calloc(256,sizeof(char));


//Integral Functions
int do_init();							//Initialize stuff, yes
void set_vars();						//Sets initial values of many vectors and variables
void do_main_loop();
void display();
void check_inputs();

//Update Functions
void update_ship(int delta_x, int delta_y);
void update_shots();
void update_monsters();
void update_explosions();

//Drawing Functions
void draw_floor();
void draw_ship();
void draw_shots();
void draw_shot(XYZ pos, int type, float theta, float phi);
void draw_terrain();
void draw_piece(terrain_node *current);
void draw_face(XYZ *verts, bool add_faces1, bool add_faces2, int cs_num);
void draw_overlay();
void draw_text(char* c, int x, int y, int z, int type);
void draw_monsters();
void draw_monster(XYZ pos, float theta, float phi, int type, float scale, int monster_id);
void draw_explosions();
void draw_explosion(XYZ pos, float rad);

//Firing functions
void launch_shot(XYZ pos, double theta, double phi, int shot_type, int shot_by);
void launch_explosion(XYZ pos, int size, float explosive, int by);

//Terrain functions
int new_id();
void generate_terrain();

//Monster functions
int new_monster_id();

//Level functions
void init_levels();
void init_level(int level_number);
void advance_level();
void advance_level(int to_level);

void game_over();

//Messages
void new_message(char *c);
void new_message(char *c, int max_life);

void ship_hit(int damage);
void monster_hit(int id, int damage);

void reset_player();

double rnd();


LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc

/////////************ Texture stuff?

AUX_RGBImageRec *LoadBMP(const char *Filename)						// Loads A Bitmap Image
{
	FILE *File=NULL;												// File Handle

	if (!Filename)													// Make Sure A Filename Was Given
	{
		return NULL;												// If Not Return NULL
	}

	File=fopen(Filename,"r");										// Check To See If The File Exists

	if (File)														// Does The File Exist?
	{
		fclose(File);												// Close The Handle
		return auxDIBImageLoad(Filename);							// Load The Bitmap And Return A Pointer
	}

	return NULL;													// If Load Failed Return NULL
}

int LoadGLTextures()									// Load Bitmaps And Convert To Textures
{
	int Status=FALSE;									// Status Indicator

	AUX_RGBImageRec *TextureImage[1];					// Create Storage Space For The Texture

	memset(TextureImage,0,sizeof(void *)*1);           	// Set The Pointer To NULL

	err_log << "TEXTURE[0]: " << texture[0] << endl;
	err_log << "TEXTURE[1]: " << texture[1] << endl;
	err_log << "TEXTURE[2]: " << texture[2] << endl;
	err_log << "TEXTURE[3]: " << texture[3] << endl;
	err_log << "TEXTURE[4]: " << texture[4] << endl;
	err_log << "TEXTURE[5]: " << texture[5] << endl;
	err_log << "TEXTURE[6]: " << texture[6] << endl;


	// Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
	if ( (TextureImage[0]=LoadBMP("Data/texture1.bmp")) )
	{
		Status=TRUE;									// Set The Status To TRUE

		glGenTextures(7, &texture[0]);					// Create The Texture
		// Typical Texture Generation Using Data From The Bitmap
		glBindTexture(GL_TEXTURE_2D, texture[0]);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	

		TextureImage[0]=LoadBMP("Data/texture2.bmp");
		glBindTexture(GL_TEXTURE_2D, texture[1]);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	

		TextureImage[0]=LoadBMP("Data/texture3.bmp");
		glBindTexture(GL_TEXTURE_2D, texture[2]);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	

		TextureImage[0]=LoadBMP("Data/texture4.bmp");
		glBindTexture(GL_TEXTURE_2D, texture[3]);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	

		TextureImage[0]=LoadBMP("Data/texture5.bmp");
		glBindTexture(GL_TEXTURE_2D, texture[4]);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	

		TextureImage[0]=LoadBMP("Data/texture6.bmp");
		glBindTexture(GL_TEXTURE_2D, texture[5]);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	

		TextureImage[0]=LoadBMP("Data/texture7.bmp");
		glBindTexture(GL_TEXTURE_2D, texture[6]);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	

	}
	err_log << "TEXTURE[0]: " << texture[0] << endl;
	err_log << "TEXTURE[1]: " << texture[1] << endl;
	err_log << "TEXTURE[2]: " << texture[2] << endl;
	err_log << "TEXTURE[3]: " << texture[3] << endl;
	err_log << "TEXTURE[4]: " << texture[4] << endl;
	err_log << "TEXTURE[5]: " << texture[5] << endl;
	err_log << "TEXTURE[6]: " << texture[6] << endl;

	if (TextureImage[0])									// If Texture Exists
	{
		if (TextureImage[0]->data)							// If Texture Image Exists
		{
			free(TextureImage[0]->data);					// Free The Texture Image Memory
		}

		free(TextureImage[0]);								// Free The Image Structure
	}

	return Status;										// Return The Status
}

GLuint LoadGLTexture( const char *filename )						// Load Bitmaps And Convert To Textures
{
	AUX_RGBImageRec *pImage;										// Create Storage Space For The Texture
	GLuint texture = 0;												// Texture ID

	pImage = LoadBMP( filename );									// Loads The Bitmap Specified By filename

	// Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
	if ( pImage != NULL && pImage->data != NULL )					// If Texture Image Exists
	{
		glGenTextures(1, &texture);									// Create The Texture

		// Typical Texture Generation Using Data From The Bitmap
		glBindTexture(GL_TEXTURE_2D, texture);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, pImage->sizeX, pImage->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, pImage->data);
//		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
//		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

		free(pImage->data);											// Free The Texture Image Memory
		free(pImage);												// Free The Image Structure
	}

	return texture;													// Return The Status
}

///////**********************************************

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix
	glGetFloatv(GL_MODELVIEW_MATRIX, empty_mat);

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
}

// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// ************************* INIT **************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************

int do_init()
{

//	init_textures=false;
	if (init_textures)
	{
		if (!LoadGLTextures())								// Jump To Texture Loading Routine ( NEW )
			return FALSE;									// If Texture Didn't Load Return FALSE

		model_ship->reloadTextures();							// Loads Model Textures
		model_monster1->reloadTextures();
		model_monster2->reloadTextures();
		model_monster3->reloadTextures();
		model_monster4->reloadTextures();
		model_shot1->reloadTextures();
		model_shot2->reloadTextures();
		model_shot3->reloadTextures();
		model_shot4->reloadTextures();
		model_explosion->reloadTextures();
	}


	glEnable(GL_COLOR_MATERIAL);
	glEnable(GL_LIGHTING);
	glEnable(GL_SMOOTH);
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHT1);
	glEnable(GL_LIGHT2);
	glEnable(GL_LIGHT3);
	glEnable(GL_LIGHT4);
	glEnable(GL_LIGHT5);
	glEnable(GL_LIGHT6);
	glEnable(GL_LIGHT7);



	glEnable(GL_TEXTURE_2D);							// Enable Texture Mapping ( NEW )
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
//	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

/*
	//Enabling lighting and lights
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHT1);
	glEnable(GL_LIGHT2);
	glEnable(GL_LIGHT3);
	glEnable(GL_LIGHT4);
	glEnable(GL_LIGHT5);
	glEnable(GL_LIGHT6);
	glEnable(GL_LIGHT7);
	glEnable(GL_SMOOTH);
	glLightfv(GL_LIGHT0, GL_AMBIENT,light_ambient[0]);
	glLightfv(GL_LIGHT0, GL_DIFFUSE,empty_light);
	glLightfv(GL_LIGHT0, GL_SPECULAR,empty_light);
*/

//	glutSetCursor(GLUT_CURSOR_DESTROY );

	return TRUE;										// Initialization Went OK
}


int DrawGLScene(GLvoid)									// Here's Where We Do All The Drawing
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear Screen And Depth Buffer
	glLoadIdentity();									// Reset The Current Modelview Matrix
	return TRUE;										// Everything Went OK
}



GLvoid KillGLWindow(GLvoid)								// Properly Kill The Window
{
	if (fullscreen)										// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);					// If So Switch Back To The Desktop
		ShowCursor(TRUE);								// Show Mouse Pointer
	}

	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									// Set hInstance To NULL
	}
}


/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/
 
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	err_log.open("errlog.txt");
	err_log << "ERROR LOG" << endl;
	err_log << "-------------" << endl;

	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	WNDCLASS	wc;						// Windows Class Structure
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)width;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_CROSS);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}
	
	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;		// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
		if (!show_cursor) ShowCursor(false);										// Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
								"OpenGL",							// Class Name
								title,								// Window Title
								dwStyle |							// Defined Window Style
								WS_CLIPSIBLINGS |					// Required Window Style
								WS_CLIPCHILDREN,					// Required Window Style
								0, 0,								// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		bits,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// Show The Window
	SetForegroundWindow(hWnd);						// Slightly Higher Priority
	SetFocus(hWnd);									// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);					// Set Up Our Perspective GL Screen

	if (!do_init())									// Initialize Our Newly Created GL Window
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	return TRUE;									// Success
}



LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle For This Window
							UINT	uMsg,			// Message For This Window
							WPARAM	wParam,			// Additional Message Information
							LPARAM	lParam)			// Additional Message Information
{
	switch (uMsg)									// Check For Windows Messages
	{
		case WM_ACTIVATE:							// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))					// Check Minimization State
			{
				active=TRUE;						// Program Is Active
			}
			else
			{
				active=FALSE;						// Program Is No Longer Active
			}

			return 0;								// Return To The Message Loop
		}

		case WM_SYSCOMMAND:							// Intercept System Commands
		{
			switch (wParam)							// Check System Calls
			{
				case SC_SCREENSAVE:					// Screensaver Trying To Start?
				case SC_MONITORPOWER:				// Monitor Trying To Enter Powersave?
				return 0;							// Prevent From Happening
			}
			break;									// Exit
		}

		case WM_CLOSE:								// Did We Receive A Close Message?
		{
			PostQuitMessage(0);						// Send A Quit Message
			return 0;								// Jump Back
		}

		case WM_KEYDOWN:							// Is A Key Being Held Down?
		{
			keys[wParam] = TRUE;					// If So, Mark It As TRUE
			return 0;								// Jump Back
		}

		case WM_KEYUP:								// Has A Key Been Released?
		{
			keys[wParam] = FALSE;					// If So, Mark It As FALSE
			return 0;								// Jump Back
		}

		case WM_LBUTTONDOWN:						//Handling of mouse buttons..
		{
			keys[256] = TRUE;
			left_button=true;
			return 0;
		}

		case WM_MBUTTONDOWN:
		{
			keys[257] = TRUE;
			return 0;
		}

		case WM_RBUTTONDOWN:
		{
			keys[258] = TRUE;
			right_button=true;
			return 0;
		}

		case WM_LBUTTONUP:
		{
			keys[256] = FALSE;
			left_button=false;
			return 0;
		}

		case WM_MBUTTONUP:
		{
			keys[257] = FALSE;
			return 0;
		}
		case WM_RBUTTONUP:
		{
			keys[258] = FALSE;
			right_button=false;
			return 0;
		}


		case WM_SIZE:								// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Width, HiWord=Height
			return 0;								// Jump Back
		}
	}

	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}



int WINAPI WinMain(	HINSTANCE	hInstance,			// Instance
					HINSTANCE	hPrevInstance,		// Previous Instance
					LPSTR		lpCmdLine,			// Command Line Parameters
					int			nCmdShow)			// Window Show State
{
//	int i,ii;

//	if (MessageBox(NULL,"Would You Like To Run In Fullscreen Mode?", "Start FullScreen?",MB_YESNO|MB_ICONQUESTION)==IDNO)
//	{
//		fullscreen=FALSE;							// Windowed Mode
//	}

	model_ship = new MilkshapeModel();									// Memory To Hold The Model
	if ( model_ship->loadModelData( "data/ship1.ms3d" ) == false )		// Loads The Model And Checks For Errors
	{
		MessageBox( NULL, "Couldn't load the model data\\model.ms3d", "Error", MB_OK | MB_ICONERROR );
		return 0;													// If Model Didn't Load Quit
	}

	model_monster1 = new MilkshapeModel();									// Memory To Hold The Model
	if ( model_monster1->loadModelData( "data/Sphere.ms3d" ) == false )		// Loads The Model And Checks For Errors
	{
		MessageBox( NULL, "Couldn't load the model data\\model.ms3d", "Error", MB_OK | MB_ICONERROR );
		return 0;													// If Model Didn't Load Quit
	}

	model_monster2 = new MilkshapeModel();									// Memory To Hold The Model
	if ( model_monster2->loadModelData( "data/Ship3.ms3d" ) == false )		// Loads The Model And Checks For Errors
	{
		MessageBox( NULL, "Couldn't load the model data\\model.ms3d", "Error", MB_OK | MB_ICONERROR );
		return 0;													// If Model Didn't Load Quit
	}

	model_monster3 = new MilkshapeModel();									// Memory To Hold The Model
	if ( model_monster3->loadModelData( "data/Ship4.ms3d" ) == false )		// Loads The Model And Checks For Errors
	{        
		MessageBox( NULL, "Couldn't load the model data\\model.ms3d", "Error", MB_OK | MB_ICONERROR );
		return 0;													// If Model Didn't Load Quit
	}

	model_monster4 = new MilkshapeModel();									// Memory To Hold The Model
	if ( model_monster4->loadModelData( "data/Ship2.ms3d" ) == false )		// Loads The Model And Checks For Errors
	{
		MessageBox( NULL, "Couldn't load the model data\\model.ms3d", "Error", MB_OK | MB_ICONERROR );
		return 0;													// If Model Didn't Load Quit
	}

	model_shot1 = new MilkshapeModel();									// Memory To Hold The Model
	if ( model_shot1->loadModelData( "data/Cylinder1.ms3d" ) == false )		// Loads The Model And Checks For Errors
	{
		MessageBox( NULL, "Couldn't load the model data\\model.ms3d", "Error", MB_OK | MB_ICONERROR );
		return 0;													// If Model Didn't Load Quit
	}

	model_shot2 = new MilkshapeModel();									// Memory To Hold The Model
	if ( model_shot2->loadModelData( "data/Cylinder2.ms3d" ) == false )		// Loads The Model And Checks For Errors
	{
		MessageBox( NULL, "Couldn't load the model data\\model.ms3d", "Error", MB_OK | MB_ICONERROR );
		return 0;													// If Model Didn't Load Quit
	}

	model_shot3 = new MilkshapeModel();									// Memory To Hold The Model
	if ( model_shot3->loadModelData( "data/Cylinder3.ms3d" ) == false )		// Loads The Model And Checks For Errors
	{
		MessageBox( NULL, "Couldn't load the model data\\model.ms3d", "Error", MB_OK | MB_ICONERROR );
		return 0;													// If Model Didn't Load Quit
	}

	model_shot4 = new MilkshapeModel();									// Memory To Hold The Model
	if ( model_shot4->loadModelData( "data/Cylinder4.ms3d" ) == false )		// Loads The Model And Checks For Errors
	{
		MessageBox( NULL, "Couldn't load the model data\\model.ms3d", "Error", MB_OK | MB_ICONERROR );
		return 0;													// If Model Didn't Load Quit
	}

	model_explosion = new MilkshapeModel();									// Memory To Hold The Model
	if ( model_explosion->loadModelData( "data/Explosion.ms3d" ) == false )		// Loads The Model And Checks For Errors
	{
		MessageBox( NULL, "Couldn't load the model data\\model.ms3d", "Error", MB_OK | MB_ICONERROR );
		return 0;													// If Model Didn't Load Quit
	}


	// Create Our OpenGL Window
	if (!CreateGLWindow("Fwoosh",SCREEN_X,SCREEN_Y,16,fullscreen))
	{
		return 0;									// Quit If Window Was Not Created
	}


/* 
	XYZ test;
	test.x=2;
	test.y=3;
	test.z=4;
	terrain.add_piece(1,test,new_id());

	test.x=5;
	test.y=6;
	test.z=7;
	terrain.add_piece(1,test,new_id());

	test.x=8;
	test.y=9;
	test.z=10;	
	terrain.add_piece(2,test,new_id());

	test.x=11;
	test.y=12;
	test.z=13;
	terrain.add_piece(2,test,new_id());

	test.x=14;
	test.y=15;
	test.z=16;
	terrain.add_piece(3,test,new_id());
	
	test.x=17;
	test.y=18;
	test.z=19;
	terrain.add_piece(1,test,new_id());


	terrain_node *test1, *test2;

	test1 = terrain.get_node(3);
	err_log << "XYZ:  " << test1->translate.x<<","<<test1->translate.y<<","<<test1->translate.z<<endl;
	err_log << "ID:   " << test1->id<< endl;
	err_log << "TYPE: " << test1->type<< endl;
	err_log << "SET:  " << terrain.get_set()<< endl;
*/

	set_vars();							//Initializes vector globals
	srand(glutGet(GLUT_ELAPSED_TIME));	//Seed randomizer

	//Base ambient light
	glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient[0]);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse[0]);
	glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular[0]);
	glLightfv(GL_LIGHT0, GL_POSITION, light_position[0]);


	//Default first light
/*	glLightfv(GL_LIGHT1, GL_AMBIENT, light_ambient[1]);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, light_diffuse[1]);
	glLightfv(GL_LIGHT1, GL_SPECULAR, light_specular[1]);
	glLightfv(GL_LIGHT1, GL_POSITION, light_position[1]);
*/

	//Defaul materials
	glMaterialfv(GL_FRONT, GL_DIFFUSE, material_diffuse[0]);
	glMaterialfv(GL_FRONT, GL_SPECULAR, material_specular[0]);
	glMaterialf(GL_FRONT, GL_SHININESS, material_shininess[0]);

	model_ship->m_pMaterials->m_ambient[0]=material_ambient[19][0];
	model_ship->m_pMaterials->m_ambient[1]=material_ambient[19][1];
	model_ship->m_pMaterials->m_ambient[2]=material_ambient[19][2];
	model_ship->m_pMaterials->m_diffuse[0]=material_diffuse[0][0];
	model_ship->m_pMaterials->m_diffuse[1]=material_diffuse[0][1];
	model_ship->m_pMaterials->m_diffuse[2]=material_diffuse[0][2];
	model_ship->m_pMaterials->m_ambient[0]=material_specular[0][0];
	model_ship->m_pMaterials->m_ambient[1]=material_specular[0][1];
	model_ship->m_pMaterials->m_ambient[2]=material_specular[0][2];
	model_ship->m_pMaterials->m_shininess=material_shininess[0];

	model_monster1->m_pMaterials->m_ambient[0]=material_ambient[19][0];
	model_monster1->m_pMaterials->m_ambient[1]=material_ambient[19][1];
	model_monster1->m_pMaterials->m_ambient[2]=material_ambient[19][2];
	model_monster1->m_pMaterials->m_diffuse[0]=material_diffuse[0][0];
	model_monster1->m_pMaterials->m_diffuse[1]=material_diffuse[0][1];
	model_monster1->m_pMaterials->m_diffuse[2]=material_diffuse[0][2];
	model_monster1->m_pMaterials->m_ambient[0]=material_specular[0][0];
	model_monster1->m_pMaterials->m_ambient[1]=material_specular[0][1];
	model_monster1->m_pMaterials->m_ambient[2]=material_specular[0][2];
	model_monster1->m_pMaterials->m_shininess=material_shininess[0];

	model_monster2->m_pMaterials->m_ambient[0]=material_ambient[19][0];
	model_monster2->m_pMaterials->m_ambient[1]=material_ambient[19][1];
	model_monster2->m_pMaterials->m_ambient[2]=material_ambient[19][2];
	model_monster2->m_pMaterials->m_diffuse[0]=material_diffuse[0][0];
	model_monster2->m_pMaterials->m_diffuse[1]=material_diffuse[0][1];
	model_monster2->m_pMaterials->m_diffuse[2]=material_diffuse[0][2];
	model_monster2->m_pMaterials->m_ambient[0]=material_specular[0][0];
	model_monster2->m_pMaterials->m_ambient[1]=material_specular[0][1];
	model_monster2->m_pMaterials->m_ambient[2]=material_specular[0][2];
	model_monster2->m_pMaterials->m_shininess=material_shininess[0];

	model_monster3->m_pMaterials->m_ambient[0]=material_ambient[19][0];
	model_monster3->m_pMaterials->m_ambient[1]=material_ambient[19][1];
	model_monster3->m_pMaterials->m_ambient[2]=material_ambient[19][2];
	model_monster3->m_pMaterials->m_diffuse[0]=material_diffuse[0][0];
	model_monster3->m_pMaterials->m_diffuse[1]=material_diffuse[0][1];
	model_monster3->m_pMaterials->m_diffuse[2]=material_diffuse[0][2];
	model_monster3->m_pMaterials->m_ambient[0]=material_specular[0][0];
	model_monster3->m_pMaterials->m_ambient[1]=material_specular[0][1];
	model_monster3->m_pMaterials->m_ambient[2]=material_specular[0][2];
	model_monster3->m_pMaterials->m_shininess=material_shininess[0];

	model_monster4->m_pMaterials->m_ambient[0]=material_ambient[19][0];
	model_monster4->m_pMaterials->m_ambient[1]=material_ambient[19][1];
	model_monster4->m_pMaterials->m_ambient[2]=material_ambient[19][2];
	model_monster4->m_pMaterials->m_diffuse[0]=material_diffuse[0][0];
	model_monster4->m_pMaterials->m_diffuse[1]=material_diffuse[0][1];
	model_monster4->m_pMaterials->m_diffuse[2]=material_diffuse[0][2];
	model_monster4->m_pMaterials->m_ambient[0]=material_specular[0][0];
	model_monster4->m_pMaterials->m_ambient[1]=material_specular[0][1];
	model_monster4->m_pMaterials->m_ambient[2]=material_specular[0][2];
	model_monster4->m_pMaterials->m_shininess=material_shininess[0];

	init_levels();

//	exit(0);

	display();
	do_main_loop();

	err_log.close();

	// Shutdown
//This causes a division by zero error!  Look into later
// Maybe not anymore though...
	KillGLWindow();									// Kill The Window
	return (msg.wParam);							// Exit The Program
//	return 0;
}

// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// ************************* MAIN LOOP *********************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************


void do_main_loop()
{
	while (done==false)
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)				// Have We Received A Quit Message?
			{
				done=TRUE;							// If So done=TRUE
			}
			else									// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);				// Translate The Message
				DispatchMessage(&msg);				// Dispatch The Message
			}
		}
		else										// If There Are No Messages
		{
			// Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
			if (active)								// Program Active?
			{
				if (keys[VK_ESCAPE])				// Was ESC Pressed?
				{
					done=TRUE;						// ESC Signalled A Quit
				}
				else								// Not Time To Quit, Update Screen
				{
					time1=time2;
					time2=glutGet(GLUT_ELAPSED_TIME);
					time_difference=time2-time1;
					overall_time += time_difference;
					time_total+=time_difference;
					time_factor=time_difference/time_factor_denom;

//					err_log << time2 << endl;

					advancing_level = false;
					if (first_run)
					{
						paused=true;
						new_message(" ",300);
						new_message(" ",310);
						new_message(" ",320);
						new_message(" ",330);
						new_message(" ",340);
						new_message(" ",350);
						new_message(" ",360);
						new_message(" ",370);
						new_message(" ",380);
						new_message(" ",390);
						new_message("                                      Captain Awesome!",400);
						new_message("                                  (name may need work...)",410);
						new_message(" ",420);
						new_message("                                     By: Doug Kavendek",430);
						new_message("                                     Alpha release 0.2",440);
						new_message(" ",450);
						new_message("                               Unpause (SPACE) to begin!",460);
						first_run = false;
					}
					if (overall_time >= min_start_time) check_inputs();
					if (advancing_level)
					{
						err_log << "Main loop - advancing level" << endl;
						display();
//						exit(2);
//						paused=true;
					}
					advancing_level = false;

//					player_look_angle[0]+=2;
//					err_log << player_look_angle[0] << endl;
//					display();						// Draw The Scene
				}
			}

			/*
			if (keys[VK_F1])						// Is F1 Being Pressed?
			{
				keys[VK_F1]=FALSE;					// If So Make Key FALSE
				KillGLWindow();						// Kill Our Current Window
				fullscreen=!fullscreen;				// Toggle Fullscreen / Windowed Mode
				// Recreate Our OpenGL Window
				if (!CreateGLWindow("NeHe's OpenGL Framework",640,480,16,fullscreen))
				{
					return 0;						// Quit If Window Was Not Created
				}
			}
			*/

		}
	}
}

void display()
{
	//Clear screen and depth buffer
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

//	pModel[->reloadTextures();							// Loads Model Textures

	//Update perspective view
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(FOV,(SCREEN_X/SCREEN_Y),1,view_distance);

	//Setting up viewing cone
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(cam.at.x,cam.at.y,cam.at.z,cam.look.x,cam.look.y,cam.look.z,0,0,1);

	//All the drawing stuff
//	draw_floor();
	draw_terrain();
	draw_ship();
	draw_shots();
	draw_monsters();
	draw_explosions();
	draw_overlay();

	SwapBuffers(hDC);				// Swap Buffers (Double Buffering)
	glFlush();
}


void check_inputs()
{
	int i;

	if (!paused)
	{
		if (ship.state==1)
		{
			//Get cursor position, translate into rotation of view, reset cursor to center
			GetCursorPos(cursor_position);

			int delta_x = SCREEN_X_MID - cursor_position->x;
			int delta_y = SCREEN_Y_MID - cursor_position->y;

			cam.at.x+=( (cam.at.x+(float)cos(cam.theta*(pi_rad))*(float)cos((cam.phi+90)*(pi_rad))) -cam.at.x)*(delta_y)*mouse_sensitivity_y*camera_move_speed;
			cam.at.y+=( (cam.at.y+(float)sin(cam.theta*(pi_rad))*(float)cos((cam.phi+90)*(pi_rad))) -cam.at.y)*(delta_y)*mouse_sensitivity_y*camera_move_speed;
			cam.at.z+=( (cam.at.z+(float)sin((cam.phi+90)*(pi_rad))) -cam.at.z)*(delta_y)*mouse_sensitivity_y*camera_move_speed;

			cam.at.x+=((cam.at.x+(float)cos((cam.theta+90)*(pi_rad)))-cam.at.x)*(delta_x)*mouse_sensitivity_x*camera_move_speed;
			cam.at.y+=((cam.at.y+(float)sin((cam.theta+90)*(pi_rad)))-cam.at.y)*(delta_x)*mouse_sensitivity_x*camera_move_speed;

			update_ship(delta_x, delta_y);
			if (advancing_level || got_dead) return;
		}
		else
		{
			FOV += time_factor * FOV_mod;
			if (FOV > FOV_max)
			{
				FOV = FOV_init;
				if (lives<=0)
				{
					new_message(" ",200);
					new_message("Game Over!",200);
					new_message("Press space to restart game.",200);
					paused=true;
					advancing_level = false;
					got_dead=false;

					won=true;	//Just to ensure proper ending

//					game_over();
				}
				else
				{
					advance_level(current_level);
					score = level_score;
					got_dead=false;
					advancing_level=true;
					if (lives==1)
					{
						new_message(" ",200);
						new_message("This is your final life!",200);
					}
				}
			}
		}

	//	cam.update_camera();
		update_shots();
		update_monsters();
		update_explosions();
	}

	display();

	if (!paused)
	{
		for (i=0;i<num_bindings;i++)
		{
			if (keys[binding[i]]==true)
			{
				switch (i)
				{
				case FIRE_1:
					{
						if (ship.shot_wait <= 0)
						{
							launch_shot(ship.pos, ship.theta, -ship.phi, ship.shot_type, 0);
							ship.shot_wait = ship.shot_delay;
							ship.shot_wait2 = ship.shot_delay;
						}
						break;
					}
				case FIRE_2:
					{
						if (ship.shot_wait2 <= 0)
						{
							launch_shot(ship.pos, ship.theta, -ship.phi, ship.shot_type2, 0);
							ship.shot_wait2 = ship.shot_delay2;
							ship.shot_wait = ship.shot_delay2;
						}
						break;
					}
				case ACC_PLUS:
					{
						ship.velocity += ship.speed_change*time_factor;
						if (ship.velocity>ship.max_speed) ship.velocity = ship.max_speed;
						break;
					}
				case ACC_MINUS:
					{
						ship.velocity -= ship.speed_change*time_factor;
						if (ship.velocity<ship.min_speed) ship.velocity = ship.min_speed;
						break;
					}
				case PAUSE:
					{
						paused=true;
						keys[binding[i]] = false;	//Toggle
						break;
					}
				case LEVEL_JUMP:
					{
						advance_level();
						level_score = score;
						advancing_level = true;
						keys[binding[i]] = false;	//Toggle
						break;
					}
				case GOD_MODE:
					{
						if (god_mode)
						{
							god_mode = false;
							new_message("God mode off");
						}
						else
						{
							god_mode = true;
							new_message("God mode on");
						}
						keys[binding[i]] = false;	//Toggle
						break;
					}
				case STRAFE_L:
					{
						ship.strafe.y = ship.strafe_amt.y;
						err_log << "Strafing left" << endl;
						break;
					}
				case STRAFE_R:
					{
						ship.strafe.y = -ship.strafe_amt.y;
						err_log << "Strafing right" << endl;
						break;
					}
				case STRAFE_U:
					{
						ship.strafe.z = ship.strafe_amt.z;
						break;
					}
				case STRAFE_D:
					{
						ship.strafe.z = -ship.strafe_amt.z;
						break;
					}
				default:
					{
						//Do nothing whatsoever
						break;
					}
				}
			}
		}
	}
	else
	{
		if (keys[binding[PAUSE]] == true)
		{
			if (won)
			{
				game_over();
			}
			paused = false;
		}
		keys[binding[PAUSE]] = false;	//Toggle
	}
		
}


// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// ************************* Firing ************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************

void launch_shot(XYZ pos, double theta, double phi, int shot_type, int shot_by)
{
//	return;
	int i;
	double shot_velocity = 30;

//	theta *= 1.8;
//	phi *= 1.5;

	for (i=0;i<max_shots;i++)
	{
		if (shots[i].type==-1)
		{

			shot_velocity = shot_speeds[shot_type];
			shots[i].strength = shot_strengths[shot_type];
			
			shots[i].pos.x=pos.x;
			shots[i].pos.y=pos.y;
			shots[i].pos.z=pos.z;

			shots[i].theta = theta;
			shots[i].phi = -phi;

			shots[i].vel.x = ( (float)cos(theta*(pi_rad)) * (float)cos((phi)*(pi_rad)) * shot_velocity);
			shots[i].vel.y = ( (float)sin(theta*(pi_rad)) * (float)cos((phi)*(pi_rad)) * shot_velocity);
			shots[i].vel.z = ( (float)sin(phi*(pi_rad)) * shot_velocity);

			shots[i].type=shot_type;
			shots[i].life=0;
			shots[i].length=0;
			shots[i].shot_by = shot_by;

			shots[i].size = shot_size[shot_type]*shot_scale_factor;
			shots[i].sizeS = shots[i].size*shots[i].size;


			num_shots++;
			break;
		}
	}

	if (i>=max_shots)
	{
		err_log << "MAX shots exceeded!" << endl;
		return;
	}
}


void launch_explosion(XYZ pos, int size, float explosive, int by)
{
	//Use size+explosive for rad_max

	//Use explosive to do damage (only if explosive>0)

	size+=explosive;

	bool first = true;
	int num_add = size / 40;
//	num_add=1;
	float time_minus = 0;
	float time_offset = .005;
	float speed = .01;
	float start_size = 0;	//.5
	float max_size = 2;
	float speed_denom = 10;

	if (by==1)
	{
		err_log << "PLAYER EXPLOSION" << endl;
		num_add = 50;
//		time_offset = .5;
		max_size=.5;
//		size=0;
		speed = .005;
		speed_denom = 500;
		time_minus=0;
	}


	//Create explosions
	for (int i=0;i<max_num_explosions;i++)
	{
		if (explosions[i].state!=1)
		{
			//Use this for next explosion
			if (first)
			{
				//First explosion will be specific to size and position
				explosions[i].state = 1;
				explosions[i].pos.x = pos.x;
				explosions[i].pos.y = pos.y;
				explosions[i].pos.z = pos.z;
				explosions[i].rad = start_size;
				explosions[i].rad_max = max_size;
				explosions[i].speed = speed + .03;
				time_minus -= time_offset * time_factor;
				first=false;
			}
			else
			{
				//Subsequent explosions will have random factors
				explosions[i].state = 1;
				explosions[i].pos.x = pos.x + rnd()*size - size/2;
				explosions[i].pos.y = pos.y + rnd()*size - size/2;
				explosions[i].pos.z = pos.z + rnd()*size - size/2;
//				explosions[i].pos.x = pos.x;
//				explosions[i].pos.y = pos.y;
//				explosions[i].pos.z = pos.z;
				explosions[i].rad = start_size - time_minus;
				explosions[i].rad_max = (max_size - .5) + rnd();
				explosions[i].speed = speed + rnd()/speed_denom;
				time_minus -= time_offset * time_factor;
			}

			explosions[i].explosive = explosive;
			explosions[i].by = by;

			num_add--;
			if (num_add<=0) break;
		}
	}
}


// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// ************************* DRAWING FUNCTIONS *************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************


void draw_floor()
{
	int type=0;

	int floor_size=10000;
	int floor_grid_size=100;
	int grid=floor_grid_size/2;
	int i,j;


	if (type==0)
	{
		glColor3f(0,1,0);
		glBegin(GL_LINES);
		for (i=-floor_size;i<=floor_size;i+=floor_grid_size)
		{
			glVertex3f(i,-floor_size,0);
			glVertex3f(i,floor_size,0);
		}
		for (i=-floor_size;i<=floor_size;i+=floor_grid_size)
		{
			glVertex3f(-floor_size,i,0);
			glVertex3f(floor_size,i,0);
		}
		glEnd();
	}

	if (type==1)
	{
		for (i=-floor_size;i<floor_size;i+=floor_grid_size)
		{
			for (j=-floor_size;j<floor_size;j+=floor_grid_size)
			{
				if (((i+j)/floor_grid_size)%2==0) glColor3f(0,1,0);
				else glColor3f(1,0,0);
				glBegin(GL_POLYGON);
					glVertex3f(i-grid,j-grid,0);
					glVertex3f(i+grid,j-grid,0);
					glVertex3f(i+grid,j+grid,0);
					glVertex3f(i-grid,j+grid,0);
				glEnd();
			}
		}
	}
}

void draw_ship()
{
	glPushMatrix();

	//Hack to keep center of rotation in center
//	glTranslatef(ship_size,0,0);

	glTranslatef(ship.pos.x, ship.pos.y, ship.pos.z);
//	glutWireCube(50);


/*
	glGetFloatv(GL_MODELVIEW_MATRIX, ship_mat);
	ship_model->setTransform(ship_mat);


	bool collision = ship_model->collision(walls1_model) || ship_model->collision(walls2_model);
	if (collision)
	{
		new_message("Collision!");
	}
*/
//	glPushMatrix();
//	glLoadIdentity();
//	glTranslatef(ship.pos.x,ship.pos.y,ship.pos.z);
//	glPushMatrix();
//	glLoadIdentity();
//	origin_light[0] = 1000;
//	origin_light[1] = 500;
//	origin_light[2] = 500;
//	origin_light[3] = 1;
//	glLightfv(GL_LIGHT1, GL_POSITION, origin_light);
//	glPopMatrix();

	if (ship.shield_spin>0 && ship.state==1)
	{
		glPushMatrix();
		glTranslatef(-1000,0,0);
		model_shot3->draw();
		glPopMatrix();
		glPushMatrix();
		if (ship.shield_spin<40) glScalef(ship.shield_spin/40,ship.shield_spin/40,ship.shield_spin/40);
		glRotatef(ship.shield_spin,1,0,0);
		glutWireSphere(21,8,8);
		glPopMatrix();

		glPushMatrix();
		glTranslatef(-1000,0,0);
		model_shot4->draw();
		glPopMatrix();
		glPushMatrix();
		if (ship.shield_spin<30) glScalef(ship.shield_spin/30,ship.shield_spin/30,ship.shield_spin/30);
		glRotatef(-ship.shield_spin,0,1,0);
		glutWireSphere(23,8,8);
		glPopMatrix();
	}

	glRotatef(ship.theta, 0,0,1);
	glRotatef(ship.phi, 0,1,0);

	glRotatef(ship.theta*banking_factor,1,0,0);

//	glRotatef(90,0,0,1);
//	glRotatef(90,1,0,0);

/*
	glBegin(GL_LINE_LOOP);
		glVertex3fv(bounding_box[0]);
		glVertex3fv(bounding_box[1]);
		glVertex3fv(bounding_box[2]);
		glVertex3fv(bounding_box[3]);
		glVertex3fv(bounding_box[4]);
		glVertex3fv(bounding_box[5]);
		glVertex3fv(bounding_box[6]);
		glVertex3fv(bounding_box[7]);
	glEnd();
*/

	glColor3f(1,1,1);
//	glutWireSphere(ship_size,12,12);
	model_ship->draw();													// Draw The Model

/*
	glBegin(GL_TRIANGLES);
		glVertex3f(ship_size,0,0);
		glVertex3f(-ship_size,-ship_size2,0);
		glVertex3f(-ship_size,ship_size2,0);

		glVertex3f(ship_size,0,0);
		glVertex3f(-ship_size,ship_size2,0);
		glVertex3f(-ship_size,0,ship_size2);

		glVertex3f(ship_size,0,0);
		glVertex3f(-ship_size,0,ship_size2);
		glVertex3f(-ship_size,-ship_size2,0);
	glEnd();
*/
	glPopMatrix();

/*
	for (int i=2;i<8;i++)
	{
		glPushMatrix();
		glTranslatef(main_light_pos[i][0],main_light_pos[i][1],main_light_pos[i][2]);
		glutWireSphere(100,12,12);
		glPopMatrix();
	}
*/
//	bool collision = ship_model->collision(test_model);
//	if (collision)
//		err_log << "SHIP collision!" << endl;

}

void draw_shots()
{
	int i;
//	float length_min;

	glDisable(GL_LIGHTING);

	for (i=0;i<max_shots;i++)
	{
		if (shots[i].type!=-1)
		{
			draw_shot(shots[i].pos, shots[i].type,shots[i].theta,shots[i].phi);

/*			length_min = 900*(shots[i].size/shot_scale_factor);
			if (shots[i].shot_by==1 || shots[i].length>=length_min)
				draw_shot(shots[i].pos, shots[i].type,shots[i].theta,shots[i].phi);
*/
		}
	}

	glEnable(GL_LIGHTING);
}

void draw_shot(XYZ pos, int type, float theta, float phi)
{
	glPushMatrix();

	glTranslatef(pos.x, pos.y, pos.z);
//	glColor3fv(shot_color[type]);

	glRotatef(theta,0,0,1);
	glRotatef(phi,0,1,0);

	glScalef(shot_size[type],shot_size[type],shot_size[type]);
	glScalef(5,.5,.5);


	switch (type)
	{
	case 0:
		{
			model_shot1->draw();
			break;
		}
	case 1:
		{
			model_shot2->draw();
			break;
		}
	case 2:
		{
			model_shot3->draw();
			break;
		}
	case 3:
		{
			model_shot4->draw();
			break;
		}
	case 4:
		{
			model_shot3->draw();
		}
	default:
		{
			glutSolidSphere(100, 8, 8);
			break;
		}
	}

/*
	glBegin(GL_TRIANGLES);
		glVertex3f(0,0,0);
		glVertex3f(-25,-10,0);
		glVertex3f(-25,10,0);

		glVertex3f(0,0,0);
		glVertex3f(-25,10,0);
		glVertex3f(-25,0,10);

		glVertex3f(0,0,0);
		glVertex3f(-25,0,10);
		glVertex3f(-25,-10,0);
	glEnd();
*/

	glPopMatrix();
}

void draw_terrain()
{
	int i;
	int cutoff;
	terrain_node *current;

//	glDisable(GL_LIGHT0);

	glPushMatrix();
	glLoadIdentity();
	origin_light[0] = 0;
	origin_light[1] = -2000;
	origin_light[2] = 0;
	glLightfv(GL_LIGHT1, GL_POSITION, origin_light);
	glPopMatrix();

	i = (int)(ship.pos.x / straight_length);
	cutoff = i + num_shown_terrain;

/*	if (first_walls)
	{
		delete walls1_model;
		walls1_model = newCollisionModel3D();
		delete walls2_model;
		walls2_model = newCollisionModel3D();
	}
*/

	if (rebuild_walls)
	{
		delete walls1_model;
		walls1_model = walls2_model;
		walls2_model = newCollisionModel3D();
	}

	for (; i<cutoff; i++)
	{
		if (i>=terrain_length) break;
		current = terrain.get_node(i);

		glPushMatrix();
		glTranslatef(current->translate.x,current->translate.y,current->translate.z);

/*		if (current->id == ship.piece_id)
		{
			glGetFloatv(GL_MODELVIEW_MATRIX, walls1_mat);
			walls1_model->setTransform(walls1_mat);
		}
		if (current->id == (ship.piece_id+1))
		{
			glGetFloatv(GL_MODELVIEW_MATRIX, walls2_mat);
			walls2_model->setTransform(walls2_mat);
		}
*/
		draw_piece(current);

		if (rebuild_walls && (current->id==(ship.piece_id+1) || ship.piece_id+1>=terrain_length))
		{
			walls2_model->finalize();
			rebuild_walls=false;
		}
		if (first_walls && current->id==(ship.piece_id+1))
		{
			walls1_model->finalize();
			walls2_model->finalize();
			first_walls=false;
		}
		glPopMatrix();
	}

//	glEnable(GL_LIGHT0);

}

void draw_piece(terrain_node *current)
{
	XYZ verts[4];
	int i,j;
	bool add_faces1 = false;
	bool add_faces2 = false;

	int overlap = 1000;
	int wire_offset = 50;

	if (current==NULL) return;

	//Draw end net
	if (current->type==T_END)
	{
		if (init_textures)
		{
			glPushMatrix();
			glLoadIdentity();
			glTranslatef(-1000,0,0);
			if (current_set==SET_VALLEY)
				model_shot2->draw();
			if (current_set==SET_CAVE)
				model_shot1->draw();
			if (current_set==SET_SPACE)
				model_shot3->draw();
			if (current_set==SET_METAL)
				model_shot4->draw();
			glPopMatrix();
		}

		glPushMatrix();
		glLoadIdentity();
		gluLookAt(cam.at.x,cam.at.y,cam.at.z,cam.look.x,cam.look.y,cam.look.z,0,0,1);

		glDisable(GL_LIGHTING);
		glTranslatef(0,piece_width/2,piece_height/2);
		glTranslatef(current->translate.x,current->translate.y,current->translate.z);
		glRotatef(glutGet(GLUT_ELAPSED_TIME),1,0,0);
		glTranslatef(0,-piece_width/2,-piece_height/2);

		glBegin(GL_LINES);
		for (i=-overlap;i<piece_width+overlap;i+=wire_offset)
		{
			glVertex3f(0,i,-overlap);
			glVertex3f(0,i,piece_height+overlap);
		}
		for (i=-overlap;i<piece_height+overlap;i+=wire_offset)
		{
			glVertex3f(0,-overlap,i);
			glVertex3f(0,piece_width+overlap,i);
		}
		glEnd();

		glEnable(GL_LIGHTING);

		glPopMatrix();
	}

	for (i=0; i<cs_verts; i++)
	{
		verts[0].x=cs[i].x;
		verts[0].y=cs[i].y;
		verts[0].z=cs[i].z;

		verts[1].x=cs[i].x+straight_length;
		verts[1].y=cs[i].y+current->turn_y;
		verts[1].z=cs[i].z+current->turn_z;

		if (i<cs_verts-1)
		{
			verts[2].x=cs[i+1].x+straight_length;
			verts[2].y=cs[i+1].y+current->turn_y;
			verts[2].z=cs[i+1].z+current->turn_z;

			verts[3].x=cs[i+1].x;
			verts[3].y=cs[i+1].y;
			verts[3].z=cs[i+1].z;
		}
		else
		{
			verts[2].x=cs[0].x+straight_length;
			verts[2].y=cs[0].y+current->turn_y;
			verts[2].z=cs[0].z+current->turn_z;

			verts[3].x=cs[0].x;
			verts[3].y=cs[0].y;
			verts[3].z=cs[0].z;
		}

		add_faces1 = false;
		add_faces2 = false;

		//setup both models
		if (first_walls && current->id==ship.piece_id)
			add_faces1 = true;
		if (first_walls && current->id==(ship.piece_id+1))
			add_faces2 = true;
		//Setup walls2_model
		if (rebuild_walls && current->id==(ship.piece_id+1) && (ship.piece_id+1)<terrain_length)
			add_faces2 = true;


		srand(i);	//Ensure seeded same inside each piece

		draw_face(verts,add_faces1,add_faces2,i);
	}
}


void draw_face(XYZ *verts, bool add_faces1, bool add_faces2,int cs_num)
{
	int k=0;
	int l, a, b;
	double i,j;
	XYZ end[2];
	XYZ new_verts[25];
	double noise2 = noise/2;
	float noise_amount;

	//Generate inner points
	for (i=0;i<=1;i+=.25)
	{
		//Generate endpoints along cross sections
		end[0].x = verts[0].x*(1-i) + verts[3].x*(i);
		end[0].y = verts[0].y*(1-i) + verts[3].y*(i);
		end[0].z = verts[0].z*(1-i) + verts[3].z*(i);

		end[1].x = verts[1].x*(1-i) + verts[2].x*(i);
		end[1].y = verts[1].y*(1-i) + verts[2].y*(i);
		end[1].z = verts[1].z*(1-i) + verts[2].z*(i);

		//Generate interpolation between endpoints
		for (j=0;j<=1;j+=.25)
		{
			new_verts[k].x = end[0].x*(1-j) + end[1].x*(j);
			new_verts[k].y = end[0].y*(1-j) + end[1].y*(j);
			new_verts[k].z = end[0].z*(1-j) + end[1].z*(j);
			k++;
		}
	}
	
	//Find normal
	U.x = verts[0].x - verts[1].x;
	U.y = verts[0].y - verts[1].y;
	U.z = verts[0].z - verts[1].z;

	V.x = verts[2].x - verts[1].x;
	V.y = verts[2].y - verts[1].y;
	V.z = verts[2].z - verts[1].z;

	normal.x = (U.y * V.z) - (U.z * V.y);
	normal.y = (U.z * V.x) - (U.x * V.z);
	normal.z = (U.x * V.y) - (U.y * V.x);

	distance = sqrt(normal.x*normal.x + normal.y*normal.y + normal.z*normal.z);

	normal.x /= distance;
	normal.y /= distance;
	normal.z /= distance;

	noise_offset = cs_offsets[cs_num];
	noise = cs_noises[cs_num];
//	noise2 = noise/2;

	//Add noise to inner vertices
	for (k=6;k<19;k++)
	{
		if (k==9 || k==14) k+=2;

		float noise_amount = ( (rnd() * noise) - noise/2 );

		new_verts[k].x += (noise_offset*normal.x) + normal.x * noise_amount;
		new_verts[k].y += (noise_offset*normal.y) + normal.y * noise_amount;
		new_verts[k].z += (noise_offset*normal.z) + normal.z * noise_amount;
	}

	glBindTexture(GL_TEXTURE_2D, texture[texture_list[cs_num]]);
	float tx;

	//Display strips
	glPushMatrix();
	for (l=0;l<4;l++)
	{
//		glColor3f((double)rand()/(double)RAND_MAX,(double)rand()/(double)RAND_MAX,(double)rand()/(double)RAND_MAX);
		if (init_textures) glColor3f(1,1,1);
		for (k=0;k<4;k++)
		{
			if (polygonal_walls) glBegin(GL_TRIANGLE_FAN);
			else glBegin(GL_LINE_STRIP);

			a = ((l+1)*5)+k;
			b = (l*5)+k;
			if (!init_textures) glColor3f(rnd(),rnd(),rnd());
			
			glTexCoord2f(0.0f, 0.0f);
			glVertex3f( new_verts[a].x, new_verts[a].y, new_verts[a].z );
			a++;
			glTexCoord2f(1.0f, 0.0f);
			glVertex3f( new_verts[a].x, new_verts[a].y, new_verts[a].z );

			b++;
			glTexCoord2f(1.0f, 1.0f);
			glVertex3f( new_verts[b].x, new_verts[b].y, new_verts[b].z );
			b--;
			glTexCoord2f(0.0f, 1.0f);
			glVertex3f( new_verts[b].x, new_verts[b].y, new_verts[b].z );
			glEnd();

			a--;

			if (k<4)
			{
				if (add_faces1)
				{
					walls1_model->addTriangle(new_verts[a].x,new_verts[a].y,new_verts[a].z,
										new_verts[b].x,new_verts[b].y,new_verts[b].z,
										new_verts[a+1].x,new_verts[a+1].y,new_verts[a+1].z);
					walls1_model->addTriangle(new_verts[a+1].x,new_verts[a+1].y,new_verts[a+1].z,
										new_verts[b].x,new_verts[b].y,new_verts[b].z,
										new_verts[b+1].x,new_verts[b+1].y,new_verts[b+1].z);
				}
				if (add_faces2)
				{
					walls2_model->addTriangle(new_verts[a].x,new_verts[a].y,new_verts[a].z,
										new_verts[b].x,new_verts[b].y,new_verts[b].z,
										new_verts[a+1].x,new_verts[a+1].y,new_verts[a+1].z);
					walls2_model->addTriangle(new_verts[a+1].x,new_verts[a+1].y,new_verts[a+1].z,
										new_verts[b].x,new_verts[b].y,new_verts[b].z,
										new_verts[b+1].x,new_verts[b+1].y,new_verts[b+1].z);
				}
			}
		}
//		glEnd();
	}
	glPopMatrix();
}


void draw_overlay()
{
	int i, x, y, y_diff, x_diff;
	int z = 2000;
	int x_max, y_max;
	char *c = (char*)calloc(512,sizeof(char));
	int width;
	int max_bar = 100;
	int min_bar = 30;

	const int num_digits = 10;
	char d[num_digits];
	i=num_digits-1;
	int temp_score = score;
	char *dtemp = (char*)calloc(16,sizeof(char));

	glColor3f(1,1,0);

	glPushMatrix();

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0,rx,0,ry,-2000,2000);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(0,0,500,0,0,0,0,1,0);

	//Do not use lighting for overlay
	glDisable(GL_LIGHTING);

	//Draw shields & armor


	if (init_textures)
	{
		glPushMatrix();
		glTranslatef(-1000,0,0);
		model_monster3->draw();
		glPopMatrix();
	}

	//Draw score
	for (;i>=0;i--)
	{
		sprintf(dtemp,"%i",temp_score % 10);
		d[i] = dtemp[0];
		temp_score /= 10;
	}
	int dwidth = 30;
	x = rx/2 - dwidth*(num_digits/2);
	y=ry-25;
	for (i=0;i<num_digits;i++)
	{
		c = (char*)calloc(2,sizeof(char));
		c[0] = d[i];
		c[1] = 0;
		draw_text(c,x,y,z,1);
		x+=dwidth;
	}



	if (init_textures)
	{
		glPushMatrix();
		glTranslatef(-1000,0,0);
		model_shot4->draw();
		glPopMatrix();
	}

	x=rx-100;
	y=ry-25;
	temp_message = (char*)calloc(256,sizeof(char));
	sprintf(temp_message,"Lives: %i",lives);
	draw_text(temp_message,x,y,z,1);

	int offset=2;
	x= 40;
	y= min_bar;
	width = 20;
	y_max = ry-max_bar;
	glBegin(GL_LINE_LOOP);
	glVertex3f(x-offset-1,y-offset-1,z);
	glVertex3f(x-offset-1,y_max+offset,z);
	glVertex3f(x+width+offset,y_max+offset,z);
	glVertex3f(x+width+offset,y-offset-1,z);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex3f(x+width,y,z);
	glVertex3f(x,y,z);
	y = y + ((double)ship.shield/(double)ship.shield_max)*(y_max-y);
	glVertex3f(x,y,z);
	glVertex3f(x+width,y,z);
	glEnd();

	c="Shields";
	draw_text(c,20,5,z,1);

	
	if (init_textures)
	{
		glPushMatrix();
		glTranslatef(-1000,0,0);
		model_shot2->draw();
		glPopMatrix();
	}

	x += width + 60;
	y= min_bar;
	y_max = ry-max_bar;
	glBegin(GL_LINE_LOOP);
	glVertex3f(x-offset-1,y-offset-1,z);
	glVertex3f(x-offset-1,y_max+offset,z);
	glVertex3f(x+width+offset,y_max+offset,z);
	glVertex3f(x+width+offset,y-offset-1,z);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex3f(x+width,y,z);
	glVertex3f(x,y,z);
	y = y + ((double)ship.armor/(double)ship.armor_max)*(y_max-y);
	glVertex3f(x,y,z);
	glVertex3f(x+width,y,z);
	glEnd();

	c="Armor";
	draw_text(c,100,5,z,1);


	if (init_textures)
	{
		glPushMatrix();
		glTranslatef(-1000,0,0);
		model_explosion->draw();
		glPopMatrix();
	}

	x = rx-80;
	y= min_bar;
	y_max = ry-max_bar;
	glBegin(GL_LINE_LOOP);
	glVertex3f(x-offset-1,y-offset-1,z);
	glVertex3f(x-offset-1,y_max+offset,z);
	glVertex3f(x+width+offset,y_max+offset,z);
	glVertex3f(x+width+offset,y-offset-1,z);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex3f(x+width,y,z);
	glVertex3f(x,y,z);
	y = y + ((double)(ship.velocity-ship.min_speed)/(double)(ship.max_speed-ship.min_speed))*(y_max-y);
	glVertex3f(x,y,z);
	glVertex3f(x+width,y,z);
	glEnd();

	c="Speed";
	draw_text(c,rx-100,5,z,1);




/*
	//Draw title
	glColor3f(0,0,0);
	glBegin(GL_POLYGON);
		glVertex3f(0,ry,100);
		glVertex3f(rx-1,ry,100);
		glVertex3f(rx-1,ry-35,100);
		glVertex3f(0,ry-35,100);
	glEnd();
	glColor3f(1,0,0);
	glBegin(GL_LINE_LOOP);
		glVertex3f(0,ry,100);
		glVertex3f(rx-1,ry,100);
		glVertex3f(rx-1,ry-35,100);
		glVertex3f(0,ry-35,100);
	glEnd();
	c="GAMENAME  -  by Doug Kavendek";
	glColor3f(1,1,0);
	draw_text(c,400,ry-25,200,1);
*/

	if (init_textures)
	{
		glPushMatrix();
		glTranslatef(-1000,0,0);
		model_monster4->draw();
		glPopMatrix();
	}

	x=200;
	y_diff=-20;
	y = ry-40;
	for (i=0;i<40;i++)
	{
//		c=NULL;
		c = messages.get_message(i);
		if (c!=NULL)
		{
			draw_text(c,x,y+y_diff,z,1);
		}
		else
			break;
		y_diff-=20;
	}
	messages.age_messages(time_factor);


	glEnable(GL_LIGHTING);

}

void draw_text(char* c, int x, int y, int z, int type)
{
	//Takes string input and outputs text one char at a time

	int i,cl,ox;
	int cont=1;

	//Determines length of string
	i=0;
	while (cont==1)
	{ 
		i++;
		if (i>=255 || c[i]==0) cont=0;
	}
	cl=i;

	ox=x;

	for (i=0;i<cl;i++)
	{
		if (c[i]=='\n')
		{
			x=ox;
			y-=15;
		}
		glRasterPos3i(x,y,z);
		if (type==1)
		{
			//Title font
			glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24, c[i]);
			x+=glutBitmapWidth(GLUT_BITMAP_TIMES_ROMAN_24, c[i]);
		}
		else
		{
			//Default font
			glutBitmapCharacter(GLUT_BITMAP_HELVETICA_10, c[i]);
			x+=glutBitmapWidth(GLUT_BITMAP_HELVETICA_10, c[i]);
		}
	}

	c="";
}

void draw_monsters()
{
	int i;
	for (i=0;i<=num_monsters;i++)
	{
		if (monsters[i].state!=-1)
		{
//			glPushMatrix();
//			glTranslatef(monsters[i].pos.x,monsters[i].pos.y,monsters[i].pos.z);
//			glutWireCube(monsters[i].size*2);
//			glPopMatrix();
			draw_monster(monsters[i].pos,monsters[i].theta,monsters[i].phi,monsters[i].model,monsters[i].scale,i);
		}
	}
}

void draw_monster(XYZ pos, float theta, float phi, int type, float scale, int monster_id)
{
	glPushMatrix();

	glTranslatef(pos.x,pos.y,pos.z);

	if (monsters[monster_id].shield_spin>0)
	{
		glPushMatrix();
		glLoadIdentity();
		glTranslatef(-1000,0,0);
		model_shot1->draw();
		glPopMatrix();
		glPushMatrix();
		if (monsters[monster_id].shield_spin<40) glScalef(monsters[monster_id].shield_spin/40,monsters[monster_id].shield_spin/40,monsters[monster_id].shield_spin/40);
		glRotatef(-monsters[monster_id].shield_spin,0,1,0);
		glutWireSphere(monsters[monster_id].size,8,8);
		glPopMatrix();
	}

	if (monsters[monster_id].type!=0)
	{
		glRotatef(theta,0,0,1);
		glRotatef(phi,0,1,0);
	}
	else
	{
		glRotatef((int)monsters[monster_id].life%360,1,0,0);
		glRotatef((int)(monsters[monster_id].life/2)%360,0,1,0);
	}
	glScalef(scale,scale,scale);

//	glTranslatef(-monsters[monster_id].size,0,0);

	glColor3f(1,1,1);

	switch (type)
	{
	case 0:
		{
			model_ship->draw();
			break;
		}
	case 1:
		{
			model_monster1->draw();
			break;
		}
	case 2:
		{
			model_monster2->draw();
			break;
		}
	case 3:
		{
			model_monster3->draw();
			break;
		}
	case 4:
		{
			model_monster4->draw();
			break;
		}
	}


	glPopMatrix();
}


void draw_explosions()
{
	for (int i=0;i<max_num_explosions;i++)
	{
		if (explosions[i].state==1)
		{
			draw_explosion(explosions[i].pos,explosions[i].rad);
		}
	}
}

void draw_explosion(XYZ pos, float rad)
{
	glPushMatrix();
	glTranslatef(pos.x,pos.y,pos.z);

	glScalef(rad,rad,rad);

	//Sub for model
	model_explosion->draw();

	glPopMatrix();
}


// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// ************************* UPDATING FUNCTIONS ************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************

void update_ship(int delta_x, int delta_y)
{
	float t1[9],t2[9];
	int new_piece_id;
	XYZ old_ship;
	XYZ old_cam;
	bool collision = false;
	bool ray_collision = false;
	bool cam1_collision = false;
	bool cam2_collision = false;
	XYZ end[2];
	XYZ center;
	double j;
	int i, k;
	terrain_node *current;
	float explosive;

	ship.shield += shield_recharge * time_factor;
	if (ship.shield>ship.shield_max)
		ship.shield=ship.shield_max;

	ship.shield_spin -= time_factor;
	if (ship.shield_spin<0)
		ship.shield_spin=0;

	if (ship.shot_wait>0)
		ship.shot_wait -= time_factor;
	if (ship.shot_wait2>0)
		ship.shot_wait2 -= time_factor;

	double theta_weight = .12;		//.06 | .07  | .12
	double phi_weight = .12;		//.1  | .08  | .12

	ship.theta = delta_x * theta_weight;
	ship.phi = -1 * delta_y * phi_weight;

	old_ship.x = ship.pos.x;
	old_ship.y = ship.pos.y;
	old_ship.z = ship.pos.z;

	ship.pos.x += ( (float)cos(ship.theta*(pi_rad)) * (float)cos((ship.phi)*(pi_rad)) * ship.velocity * time_factor);
	ship.pos.y += ( (float)sin(ship.theta*(pi_rad)) * (float)cos((ship.phi)*(pi_rad)) * ship.velocity * time_factor);
	ship.pos.z += ( (float)sin(-ship.phi*(pi_rad)) * 2 * ship.velocity * time_factor);

	ship.pos.y += ship.strafe.y * ship.velocity;
	ship.pos.z += ship.strafe.z * ship.velocity;
	ship.strafe.y=0;
	ship.strafe.z=0;

	glPushMatrix();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(cam.at.x,cam.at.y,cam.at.z,cam.look.x,cam.look.y,cam.look.z,0,0,1);

	//Find matrix for ship's bounding box & matrix for camera
	glPushMatrix();
//	glTranslatef(ship_size,0,0);
	glTranslatef(ship.pos.x, ship.pos.y, ship.pos.z);

/*	glPushMatrix();
	glTranslatef(ship_offset.x,ship_offset.y,ship_offset.z);
	glGetFloatv(GL_MODELVIEW_MATRIX, cam_mat);
	glPopMatrix();
*/
	glRotatef(ship.theta, 0,0,1);
	glRotatef(ship.phi, 0,1,0);
	glGetFloatv(GL_MODELVIEW_MATRIX, ship_mat);
	ship_model->setTransform(ship_mat);
	glPopMatrix();

	//Find matrix for terrain
	i = (int)(ship.pos.x / straight_length);
	j=i+2;
	for (; i<j; i++)
	{
		if (i>=terrain_length) break;
		current = terrain.get_node(i);

		glPushMatrix();
		glTranslatef(current->translate.x,current->translate.y,current->translate.z);
		if (current->id == ship.piece_id)
		{
			glGetFloatv(GL_MODELVIEW_MATRIX, walls1_mat);
			walls1_model->setTransform(walls1_mat);
		}
		else if (current->id == (ship.piece_id+1))
		{
			glGetFloatv(GL_MODELVIEW_MATRIX, walls2_mat);
			walls2_model->setTransform(walls2_mat);
		}
		glPopMatrix();
	}

	glPopMatrix();

	//Find matrix for terrain - used in ray collision
	glPushMatrix();
	i = (int)(ship.pos.x / straight_length);
	current = terrain.get_node(i);
	glLoadIdentity();


	i = (int)(ship.pos.x / straight_length);
	j=i+2;
	for (; i<j; i++)
	{
		if (i>=terrain_length) break;
		current = terrain.get_node(i);

		glPushMatrix();
		if (current->id == ship.piece_id)
		{
			glTranslatef(current->translate.x,current->translate.y,current->translate.z);
			glGetFloatv(GL_MODELVIEW_MATRIX, ray1_mat);
		}
		else if (current->id == (ship.piece_id+1))
		{
			glTranslatef(current->translate.x,current->translate.y,current->translate.z);
			glGetFloatv(GL_MODELVIEW_MATRIX, ray2_mat);
		}
		glPopMatrix();
	}



/*
	glPushMatrix();
	if (current!=NULL)
	{
		glTranslatef(current->translate.x,current->translate.y,current->translate.z);
		glGetFloatv(GL_MODELVIEW_MATRIX, ray1_mat);
	}
	else err_log << "ERROR loading RAY1_MAT" <<endl;
	glPopMatrix();

	i++;
 	current = terrain.get_node(i);
	if (current!=NULL)
	{
		glTranslatef(current->translate.x,current->translate.y,current->translate.z);
		glGetFloatv(GL_MODELVIEW_MATRIX, ray2_mat);
	}
	else err_log << "ERROR loading RAY1_MAT" << endl;
*/
	glPopMatrix();


	//Find center point of cross section where ship lies
	i = (int)(ship.pos.x / straight_length);
	current = terrain.get_node(i);
	end[0].x = current->translate.x;
	end[0].y = current->translate.y + piece_width2;
	end[0].z = current->translate.z + piece_height2;
	end[1].x = current->translate.x + straight_length;
	end[1].y = current->translate.y + current->turn_y + piece_width2;
	end[1].z = current->translate.z + current->turn_z + piece_height2;
	j = (ship.pos.x - ship.piece_id*straight_length) / straight_length;
	center.x = end[0].x*(1-j) + end[1].x*(j);
	center.y = end[0].y*(1-j) + end[1].y*(j);
	center.z = end[0].z*(1-j) + end[1].z*(j);
	//Pseudo-normal - later used in collision reflection
	//Create pseudo-normal with ship->center vector
	normal.x = (int) (center.x - ship.pos.x);
	normal.y = (int) (center.y - ship.pos.y);
	normal.z = (int) (center.z - ship.pos.z);
	distance = sqrt(normal.x*normal.x + normal.y*normal.y + normal.z*normal.z);
	if (distance!=0)
	{
		normal.x /= distance;
		normal.y /= distance;
		normal.z /= distance;
	}

	ray_origin[0] = ship.pos.x;
	ray_origin[1] = ship.pos.y;
	ray_origin[2] = ship.pos.z;
	ray_dir[0] = normal.x;
	ray_dir[1] = normal.y;
	ray_dir[2] = normal.z;

	float ship_origin[3];
	ship_origin[0] = ship.pos.x;
	ship_origin[1] = ship.pos.y;
	ship_origin[2] = ship.pos.z;

	collision = ( ship_model->collision(walls1_model) ||
				  ship_model->collision(walls2_model) );

	new_piece_id = (int)ship.pos.x/straight_length;
	if (!collision)
	{
		walls1_model->setTransform(ray1_mat);
		walls2_model->setTransform(ray2_mat);
		ray_collision = ( walls1_model->rayCollision(ray_origin,ray_dir,false,0,distance) ||
						  walls1_model->rayCollision(ray_origin,ray_dir,false,0,distance) );
		if (ship.piece_id != new_piece_id)
			ray_collision = false;
	}

	if (collision || ray_collision)
	{
		err_log << "Collision detected." << endl;
//		if (!ray_collision) new_message("Collision!");
//		else new_message("Ray collision!");

		ship_hit(wall_damage);
		if (advancing_level) return;

		repulsion_phi = rad_pi*(double)acos(normal.y);
		//Take z component into account
		if (normal.z < 0) repulsion_phi *= -1;

		if (collision)
		{
			ship.pos.x = old_ship.x;
			ship.pos.y = old_ship.y;
			ship.pos.z = old_ship.z;
			repulsion_mag = repulsion_amt;
		}
		else
			repulsion_mag = repulsion_amt*ray_multiplier;
	}

	//Recreate repulsion forces - why the flip in x/y?
	repulsion.x = 0;
	repulsion.y = (float)cos(repulsion_phi*(pi_rad)) * repulsion_mag;
	repulsion.z = (float)sin(repulsion_phi*(pi_rad)) * repulsion_mag;

	//Apply repulsion forces
	ship.pos.x += repulsion.x * time_factor;
	ship.pos.y += repulsion.y * time_factor;
	ship.pos.z += repulsion.z * time_factor;

/*
	//Update ship's light
	main_light_pos[1][0] = ship.pos.x;
	main_light_pos[1][1] = ship.pos.y;
	main_light_pos[1][2] = ship.pos.z;
	glLightfv(GL_LIGHT1, GL_POSITION, main_light_pos[1]);
*/

	//Degrade repulsion forces
	repulsion_mag -= repulsion_red * time_factor;
	if (repulsion_mag<0) repulsion_mag = 0;

	old_cam.x = cam.at.x;
	old_cam.y = cam.at.y;
	old_cam.z = cam.at.z;

	//Update camera from ship position
	cam.at.x = ship.pos.x + ship_offset.x;
	cam.at.y = ship.pos.y + ship_offset.y;
	cam.at.z = ship.pos.z + ship_offset.z;


	//Offset camera based on distance from center to avoid cam clipping
	//
	//Get current terrain piece info
	i = (int)(ship.pos.x / straight_length);
	current = terrain.get_node(i);

	//Get y,z max
	int y_max = current->translate.y + ((double)(ship.pos.x-current->translate.x)/(double)straight_length)*(double)current->turn_y;
	int z_max = current->translate.z + ((double)(ship.pos.x-current->translate.x)/(double)straight_length)*(double)current->turn_z;

	//Find center point
	center.x = 0;
	center.y = y_max + piece_width/2;
	center.z = z_max + piece_height/2;

	//Offset the ship_offset
	ship_offset.y = ship_base_offset.y - offset_factor*(ship.pos.y-center.y);
	ship_offset.z = ship_base_offset.z - offset_factor*(ship.pos.z-center.z);

	cam.update_camera();

	//Log entrance of new piece - already set
//	new_piece_id = (int)ship.pos.x/straight_length;
	if (ship.piece_id != new_piece_id)
	{
//		new_message("Entering new piece...");
		ship.piece_id = new_piece_id;
		err_log << "ENTERING new piece : " << new_piece_id << endl;
		
		if (terrain.get_node(ship.piece_id)->type==T_END)
		{
			//End of level reached - advance to next level
			advance_level();
			level_score = score;
			advancing_level = true;
			return;
		}

		rebuild_walls = true;

		current = terrain.get_node(new_piece_id+5);

		/*
		//Set new lights
		main_light_pos[2][0] = main_light_pos[3][0];
		main_light_pos[2][1] = main_light_pos[3][1];
		main_light_pos[2][2] = main_light_pos[3][2];
		main_light_pos[3][0] = main_light_pos[4][0];
		main_light_pos[3][1] = main_light_pos[4][1];
		main_light_pos[3][2] = main_light_pos[4][2];
		main_light_pos[4][0] = main_light_pos[5][0];
		main_light_pos[4][1] = main_light_pos[5][1];
		main_light_pos[4][2] = main_light_pos[5][2];
		main_light_pos[5][0] = main_light_pos[6][0];
		main_light_pos[5][1] = main_light_pos[6][1];
		main_light_pos[5][2] = main_light_pos[6][2];
		main_light_pos[6][0] = main_light_pos[7][0];
		main_light_pos[6][1] = main_light_pos[7][1];
		main_light_pos[6][2] = main_light_pos[7][2];
		if (current!=NULL)
		{
			main_light_pos[7][0] = current->translate.x;
			main_light_pos[7][1] = current->translate.y + piece_width/2;
			main_light_pos[7][2] = current->translate.z + piece_height/2;
		}
		else
		{
			main_light_pos[7][0] = 0;
			main_light_pos[7][1] = 0;
			main_light_pos[7][2] = 0;
		}

		err_log << "NEW LIGHT positions..." << endl;
		err_log <<main_light_pos[2][0]<<", "<<main_light_pos[2][1]<<", "<<main_light_pos[2][2]<<endl;
		err_log <<main_light_pos[3][0]<<", "<<main_light_pos[3][1]<<", "<<main_light_pos[3][2]<<endl;
		err_log <<main_light_pos[4][0]<<", "<<main_light_pos[4][1]<<", "<<main_light_pos[4][2]<<endl;
		err_log <<main_light_pos[5][0]<<", "<<main_light_pos[5][1]<<", "<<main_light_pos[5][2]<<endl;
		err_log <<main_light_pos[6][0]<<", "<<main_light_pos[6][1]<<", "<<main_light_pos[6][2]<<endl;
		err_log <<main_light_pos[7][0]<<", "<<main_light_pos[7][1]<<", "<<main_light_pos[7][2]<<endl;

		glLightfv(GL_LIGHT2, GL_POSITION, main_light_pos[2]);
		glLightfv(GL_LIGHT3, GL_POSITION, main_light_pos[3]);
		glLightfv(GL_LIGHT4, GL_POSITION, main_light_pos[4]);
		glLightfv(GL_LIGHT5, GL_POSITION, main_light_pos[5]);
		glLightfv(GL_LIGHT6, GL_POSITION, main_light_pos[6]);
		glLightfv(GL_LIGHT7, GL_POSITION, main_light_pos[7]);
		*/
	}

	//Check for explosions
	for (i=0;i<max_num_explosions;i++)
	{
		explosive = explosions[i].explosive * 2;
		if (explosions[i].state==1 && explosive>0 && explosions[i].by==0)
		{
			//Check distances
			if ((explosions[i].pos.x-ship.pos.x)<explosive)
			{
				distance = sqrt( (explosions[i].pos.x-ship.pos.x)*(explosions[i].pos.x-ship.pos.x) +
							(explosions[i].pos.y-ship.pos.y)*(explosions[i].pos.y-ship.pos.y) +
							(explosions[i].pos.z-ship.pos.z)*(explosions[i].pos.z-ship.pos.z) );

				if (distance<explosive)
				{
					ship_hit((explosions[i].explosive/explosive_helper)*(1 - distance/explosive));
					if (advancing_level || got_dead) return;
				}
			}
		}
	}
}

void update_shots()
{
	int i,j;
	int combined_radius;
	monster mon;

	for (i=0;i<max_shots;i++)
	{
		if (shots[i].type!=-1)
		{
			if (shots[i].life >= shot_life)
				shots[i].type = -1;
			else
			{
				shots[i].pos.x += shots[i].vel.x * time_factor;
				shots[i].pos.y += shots[i].vel.y * time_factor;
				shots[i].pos.z += shots[i].vel.z * time_factor;
				shots[i].life += time_factor;
				if (shots[i].shot_by==0)
					shots[i].length += shots[i].vel.x * time_factor;
			}

			if (shots[i].shot_by==0)
			{
				//Shot by player - compare against monsters
				for (j=1;j<=num_monsters;j++)
				{
					if (monsters[j].state>-1)
					{
						mon = monsters[j];
						//Monster is alive
						combined_radius = mon.size+shots[i].size;
						if ( abs(mon.pos.x-shots[i].pos.x) <= combined_radius &&
							 abs(mon.pos.y-shots[i].pos.y) <= combined_radius &&
							 abs(mon.pos.z-shots[i].pos.z) <= combined_radius)
						{
							//Shot is within basic range.
							distance = (mon.pos.x-shots[i].pos.x)*(mon.pos.x-shots[i].pos.x) + 
										(mon.pos.y-shots[i].pos.y)*(mon.pos.y-shots[i].pos.y) + 
										(mon.pos.z-shots[i].pos.z)*(mon.pos.z-shots[i].pos.z);
							if (distance<=(combined_radius*combined_radius)*shot_helper)
							{
//								new_message("Hit monster!");
								shots[i].type = -1;
								monster_hit(j,shots[i].strength);
							}
						}
					}
				}
			}
			else
			{
				//Shot by monster - compar against player
				combined_radius = shots[i].size+ship.size;
				if ( abs(ship.pos.x-shots[i].pos.x) <= combined_radius &&
					 abs(ship.pos.y-shots[i].pos.y) <= combined_radius &&
					 abs(ship.pos.z-shots[i].pos.z) <= combined_radius)
				{
					//Shot is within basic range.
					distance = (ship.pos.x-shots[i].pos.x)*(ship.pos.x-shots[i].pos.x) + 
								(ship.pos.y-shots[i].pos.y)*(ship.pos.y-shots[i].pos.y) + 
								(ship.pos.z-shots[i].pos.z)*(ship.pos.z-shots[i].pos.z);
					if (distance<=(combined_radius*combined_radius)*defense_helper)
					{
//						new_message("Ship is hit!");
						shots[i].type = -1;
						ship_hit(shots[i].strength);
						if (advancing_level || got_dead) return;
					}
				}
			}
		}
	}
}

void update_monsters()
{
	int i;
	int goal_padding = 300;
	int piece_id;
	terrain_node *current;
	int goal_n_y = 100;
	int goal_n_z = 100;
	float throwaway;
	monster mon;
	float distance;
	bool no_LOS = true;
	float new_theta, new_phi, d_theta, d_phi;
	float combined_radius;


	//For each live monster
	for (i=1; i<=num_monsters; i++)
	{
		mon = monsters[i];

		if (mon.state<-1)
		{
			//Increase state until -1 is reached
			monsters[i].state+=time_factor;
			if (monsters[i].state>-1)
				monsters[i].state=-1;
		}

		monsters[i].shield_spin -= time_factor*2;
		if (monsters[i].shield_spin<0)
			monsters[i].shield_spin=0;

		if (mon.state>-1)
		{
			//Monster is alive
			monsters[i].life += time_factor;

			//Kill monster if behind player
			if (monsters[i].pos.x < ship.pos.x)
			{
				monsters[i].state=-1;
			}

			if (mon.state==0)
			{
				//Monster is asleep

				//Check distance vs trigger_distance
				if (mon.pos.x - ship.pos.x <= mon.trigger_distance)
				{
					//Activate monster
					mon.state=1;
					err_log << "Monster " << i << " woken up." << endl;
				}
			}

			if (mon.state!=0)
			{
				//Monster is awake

				//Degrade shot_wait
				if (monsters[i].shot_wait>0)
					monsters[i].shot_wait -= time_factor;


				//Handle collisions with player
				combined_radius = mon.size+ship.size;
				if ( abs(ship.pos.x-mon.pos.x) <= combined_radius &&
					 abs(ship.pos.y-mon.pos.y) <= combined_radius &&
					 abs(ship.pos.z-mon.pos.z) <= combined_radius)
				{
					//Basic condition met
					distance = (ship.pos.x-mon.pos.x)*(ship.pos.x-mon.pos.x) + 
								(ship.pos.y-mon.pos.y)*(ship.pos.y-mon.pos.y) + 
								(ship.pos.z-mon.pos.z)*(ship.pos.z-mon.pos.z);
					if (distance<=combined_radius*combined_radius)
					{
						//Definitely collided
//						paused=true;
//						new_message("Collided with monster.");
						monster_hit(i,monsters[i].mass);
						ship_hit(monsters[i].mass);
						if (advancing_level || got_dead) return;
						
						//Break from function if monster killed
						if (monsters[i].health<=0)
							return;
					}

				}




				//Create new goal (if needed)
				if (mon.speed>0 && ( mon.goal.x==-1 || (mon.pos.x-mon.goal.x)<=goal_padding ))
				{
					//Monster needs new goal

					//Find piece_id
					piece_id = mon.pos.x/straight_length;

					srand(i+piece_id);	//Seed randomizer
					throwaway=rnd()*rnd();

					//Get currend node's info
					current = terrain.get_node(piece_id);

					//If difference to next piece is within goal_padding, use lower piece
					// else use current piece
					if ( (mon.pos.x - current->translate.x) <= goal_padding )
					{
						//Within padding -> use next piece down instead
						current = terrain.get_node(piece_id - 1);
					}

					if (current==NULL)
						err_log << "Monster looking for node out of range." << endl;
					else
					{
						//Create new goal
						mon.goal.x = current->translate.x;
						mon.goal.y = current->translate.y + ( rnd() * (double)(piece_width-(2*goal_n_y)) + goal_n_y );
						mon.goal.z = current->translate.z + ( rnd() * (double)(piece_height-(2*goal_n_z)) + goal_n_z );
					}
				}

				//Only do this if monster moves!
				if (mon.speed>0)
				{

				//************** Calculate goal force ******************
				//******************************************************
				goal_force.x = mon.goal.x-mon.pos.x;
				goal_force.y = mon.goal.y-mon.pos.y;
				goal_force.z = mon.goal.z-mon.pos.z;
				distance = sqrt(goal_force.x*goal_force.x + goal_force.y*goal_force.y + goal_force.z*goal_force.z);
				if (distance!=0)
				{
					goal_force.x /= distance;
					goal_force.y /= distance;
					goal_force.z /= distance;
				}
				else
				{
					goal_force.x = 0;
					goal_force.y = 0;
					goal_force.z = 0;
				}


				//************** Calculate repulsion forces ************
				//******************************************************
				repulsion_force.x=0;
				repulsion_force.y=0;
				repulsion_force.z=0;
				for (int j=1; j<=num_monsters; j++)
				{
					if (j!=i)
					{
						repulsion_dir.x = mon.pos.x - monsters[j].pos.x;
						repulsion_dir.y = mon.pos.y - monsters[j].pos.y;
						repulsion_dir.z = mon.pos.z - monsters[j].pos.z;
						distance = repulsion_dir.x * repulsion_dir.x + 
								   repulsion_dir.y * repulsion_dir.y +
								   repulsion_dir.z * repulsion_dir.z;
//						err_log << "Intermed distance: " << distance<< endl;
//						err_log << mon.size << ", " << monsters[j].size <<", " << (mon.size + monsters[j].size)*(mon.size + monsters[j].size) << endl;
						if (distance<= (mon.size + monsters[j].size)*(mon.size + monsters[j].size) + 10000 )//10000
						{
							distance = sqrt(distance);
							if (distance!=0)
							{
								repulsion_force.x += repulsion_dir.x / distance;
								repulsion_force.y += repulsion_dir.y / distance;
								repulsion_force.z += repulsion_dir.z / distance;
							}
							else
							{
								repulsion_force.x += -1;
							}
						}
					}
				}

				//Combine forces
				force.x = goal_force.x * goal_weight;
				force.y = goal_force.y * goal_weight;
				force.z = goal_force.z * goal_weight;
				if (!(mon.type==2 && (ship.piece_id+2 >= mon.pos.x/straight_length)))
				{
					force.x += repulsion_force.x * repulsion_weight;
					force.y += repulsion_force.y * repulsion_weight;
					force.z += repulsion_force.z * repulsion_weight;
				}


				//Determine turning amount

				bool flip = true;

				if (flip) mon.phi *= -1;

				//Find new angle
				if (force.x!=0)
				{
					new_theta = rad_pi*(double)atan(force.y/force.x);
					if (force.x < 0) new_theta -= 180;
					new_phi = rad_pi*(double)atan(force.z/force.x);
					if (force.x < 0) new_phi *= -1;
				}
				else
				{
					if (force.y == 0) new_theta = 0;
					else if (force.y>0) new_theta = 90;
					else new_theta = 270;

					//? Should this be PHI or THETA?  Originally theta...
					if (force.z == 0) new_phi = 0;
					else if (force.z>=0) new_phi = 90;
					else new_phi = 270;
				}

				d_theta = new_theta - mon.theta;
				d_phi = new_phi - mon.phi;
				if (abs(d_theta) > 180)
				{
					//Convert to smaller angle
					if (d_theta>0)
						d_theta -= 360;
					else
						d_theta += 360;
				}
				if (abs(d_phi) > 180)
				{
					//Convert to smaller angle
					if (d_phi>0)
						d_phi -= 360;
					else
						d_phi += 360;
				}

				//Restrict angle movement
				if (mon.type==2 && (ship.piece_id+2 >= mon.pos.x/straight_length))
				{
					//Kamikaze has unrestricted turning towards player in range
					mon.theta += (d_theta);
					mon.phi += (d_phi);
				}
				else
				{
					mon.theta += (d_theta) * turn_tolerance;
					mon.phi += (d_phi) * turn_tolerance;
				}

				if (mon.theta >= 360) mon.theta -= 360;
				if (mon.theta <= -360) mon.theta += 360;
				if (mon.phi >= 360) mon.phi -= 360;
				if (mon.phi <= -360) mon.phi += 360;

				//Find velocity components, given new angle
				mon.vel.x = mon.speed * (double)cos(mon.theta*(pi_rad)) * (double)cos(mon.phi*(pi_rad));
				mon.vel.y = mon.speed * (double)sin(mon.theta*(pi_rad)) * (double)cos(mon.phi*(pi_rad));
				mon.vel.z = mon.speed * (double)sin(mon.phi*(pi_rad));

				//Update position from velocity
				mon.pos.x+=mon.vel.x*time_factor;
				mon.pos.y+=mon.vel.y*time_factor;
				mon.pos.z+=mon.vel.z*time_factor;

				if (flip) mon.phi *= -1;


				//Send new values to monster
				monsters[i].theta = mon.theta;
				monsters[i].phi = mon.phi;
				monsters[i].pos.x = mon.pos.x;
				monsters[i].pos.y = mon.pos.y;
				monsters[i].pos.z = mon.pos.z;
				monsters[i].vel.x = mon.vel.x;
				monsters[i].vel.y = mon.vel.y;
				monsters[i].vel.z = mon.vel.z;
				monsters[i].goal.x = mon.goal.x;
				monsters[i].goal.y = mon.goal.y;
				monsters[i].goal.z = mon.goal.z;

				mon = monsters[i];

				}//End of monster movement

				//Deal with shots

				if (mon.type==2 && (ship.piece_id+2 >= mon.pos.x/straight_length))
				{
					//Kamikaze
					monsters[i].goal.x = ship.pos.x;
					monsters[i].goal.y = ship.pos.y;
					monsters[i].goal.z = ship.pos.z;
				}

				if ( mon.shot_type!=-1 && (ship.piece_id+2 >= mon.pos.x/straight_length) )
				{
					//Monster within next two pieces & not too close
					if ( mon.shot_wait<=0 && ((mon.pos.x-ship.pos.x)>min_shooting_distance) )
					{
						//Monster able to fire
						
						//Determine if line of sight exists between mon & ship
						//Ray origin - ship
						//Ray dir - monster to ship

						//Find velocity components of ship
						ship_dir.x = (double)cos(ship.theta*(pi_rad)) * (double)cos(ship.phi*(pi_rad));
						ship_dir.y = (double)sin(ship.theta*(pi_rad)) * (double)cos(ship.phi*(pi_rad));
						ship_dir.z = (double)sin(ship.phi*(pi_rad));


						ray_origin[0] = ship.pos.x;
						ray_origin[1] = ship.pos.y;
						ray_origin[2] = ship.pos.z;
						ray_dir[0] = ray_origin[0] - mon.pos.x;
						ray_dir[1] = ray_origin[1] - mon.pos.y;
						ray_dir[2] = ray_origin[2] - mon.pos.z;
						distance = sqrt(ray_dir[0]*ray_dir[0] + ray_dir[1]*ray_dir[1] + ray_dir[2]*ray_dir[2]);
						ray_dir[0] /= distance;	//Not needed?
						ray_dir[1] /= distance;
						ray_dir[2] /= distance;

						walls1_model->setTransform(ray1_mat);	//May not be needed
						walls2_model->setTransform(ray2_mat);	//ditto
						no_LOS = ( walls1_model->rayCollision(ray_origin,ray_dir,false,0,distance) ||
								   walls1_model->rayCollision(ray_origin,ray_dir,false,0,distance) );

						if (!no_LOS)
						{
							//Line of Sight exists

							//Lead the player a bit
							lead_factor = lead_numerator/shot_speeds[mon.shot_type];
							ray_origin[0] = ship.pos.x + ship_dir.x * lead_factor * ((mon.pos.x-ship.pos.x)/lead_bits);
							ray_origin[1] = ship.pos.y + ship_dir.y * lead_factor * ((mon.pos.x-ship.pos.x)/lead_bits);
							ray_origin[2] = ship.pos.z + ship_dir.z * lead_factor * ((mon.pos.x-ship.pos.x)/lead_bits);

							//Add random bit (to account for monster accuracy)
							/*//Disabled - not random!  I need a different random function...
							ray_origin[0] += (rnd()*(float)mon.accuracy - (float)mon.accuracy2);
							ray_origin[1] += (rnd()*(float)mon.accuracy - (float)mon.accuracy2);
							ray_origin[2] += (rnd()*(float)mon.accuracy - (float)mon.accuracy2);
							*/

							//Find new ray
							ray_dir[0] = ray_origin[0] - mon.pos.x;
							ray_dir[1] = ray_origin[1] - mon.pos.y;
							ray_dir[2] = ray_origin[2] - mon.pos.z;
							distance = sqrt(ray_dir[0]*ray_dir[0] + ray_dir[1]*ray_dir[1] + ray_dir[2]*ray_dir[2]);

							//Normalize
							ray_dir[0] /= distance;
							ray_dir[1] /= distance;
							ray_dir[2] /= distance;


							//Calculate angles
							if (ray_dir[0]!=0)
							{
								new_theta = rad_pi*(double)atan(ray_dir[1]/ray_dir[0]);
								if (ray_dir[0] < 0) new_theta -= 180;
								new_phi = rad_pi*(double)atan(ray_dir[2]/ray_dir[0]);
								if (ray_dir[0] < 0) new_phi *= -1;
							}
							else
							{
								if (ray_dir[1] == 0) new_theta = 0;
								else if (ray_dir[1]>0) new_theta = 90;
								else new_theta = 270;

								//? Should this be PHI or THETA?  Originally theta...
								if (ray_dir[2] == 0) new_phi = 0;
								else if (ray_dir[2]>=0) new_phi = 90;
								else new_phi = 270;
							}

							//Fire shot
							launch_shot(mon.pos,new_theta,new_phi,mon.shot_type,1);
							monsters[i].shot_wait = mon.shot_delay;
						}
//						else
//							err_log << "No LOS" << endl;
					}
//					else
//						err_log << "WAIT: " << mon.shot_wait << endl;
				}
//				else
//				{
//					err_log << "Outside range" << endl;
//					err_log << ship.piece_id << ","<< mon.pos.x/straight_length << endl;
//				}
			}
		}
//		else err_log<< "Dead" << endl;
	}

}

void update_explosions()
{
	for (int i=0;i<max_num_explosions;i++)
	{
		if (explosions[i].state==1)
		{
			explosions[i].rad+=time_factor * explosions[i].speed;
			if (explosions[i].rad>explosions[i].rad_max)
			{
				//Kill explosion
				explosions[i].state=0;
			}
		}
	}
}



// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// ************************* TERRAIN FUNCTIONS *************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************
// *********************************************************************************


void generate_terrain()
{
	int i,j, type;
	double turn_y, turn_z;
	XYZ location;
	bool turn_y_done, turn_z_done;
	int monster_type;
	int monster_num;
	XYZ monster_pos;
	int y_min, y_max, z_min, z_max;
	char *temp;
	int y_max_offset = 200;
	int z_max_offset = 200;
	terrain_node *current;

//	terrain_string = "{UD[01,11](Rd)[03,13,22][13](dl)[13,31,03,23]D(UR)[05,22](LU)[31,13]Du[31,41]DD[13,31,21]rRS[12]l(Lu)[08,23](lU)[44](lu)[02]u[11,01,21]S(RU)[32,11,21](LU)[11,21](rU)[31,41,11](RU)(d)[19](dl)[42,22]Uu[12,03]d[11,02,21]D(RD)[49,02](RU)[39,24](rU)}";
//	terrain_string = "{SS[03]S[03]S}";


	num_monsters = 0;
	location.x=0;
	location.y=0;
	location.z=0;
	terrain.clear_terrain();

//	current_set = SET_VALLEY;

	switch (current_set)
	{
	case (SET_VALLEY):
		{
			straight_length = 2000;
			turn_length = 500;
			sharp_turn_length = 1000;
			piece_width = 1000;
			piece_height = 2000;
			piece_width2 = piece_width/2;
			piece_height2 = piece_height/2;
			player_start.x = 0;
			player_start.y = piece_width/2;
			player_start.z = piece_height/2;
			noise = 250;
			noise_offset = 0;
			texture_number = 1;
			texture_list[0] = 2;
			texture_list[1] = 1;
			texture_list[2] = 1;
			texture_list[3] = 1;
			texture_list[4] = 3;
			texture_list[5] = 3;
			texture_list[6] = 3;
			texture_list[7] = 1;
			texture_list[8] = 1;
			texture_list[9] = 1;
			ship_diffuse[0] = .4f;
			ship_diffuse[1] = .4f;
			ship_diffuse[2] = .4f;
			ship_diffuse[3] = 1;
			main_diffuse[0] = .5f;
			main_diffuse[1] = .5f;
			main_diffuse[2] = .5f;
			main_diffuse[3] = 1;
			cs_noises[0] = 150;
			cs_noises[1] = 300;
			cs_noises[2] = 300;
			cs_noises[3] = 300;
			cs_noises[4] = 0;
			cs_noises[5] = 0;
			cs_noises[6] = 0;
			cs_noises[7] = 300;
			cs_noises[8] = 300;
			cs_noises[9] = 300;
			cs_offsets[0] = 0;
			cs_offsets[1] = 0;
			cs_offsets[2] = 0;
			cs_offsets[3] = 0;
			cs_offsets[4] = 0;
			cs_offsets[5] = 0;
			cs_offsets[6] = 0;
			cs_offsets[7] = 0;
			cs_offsets[8] = 0;
			cs_offsets[9] = 0;
			fog_color[0] = 0;
			fog_color[1] = 0;
			fog_color[2] = 0;
			fog_density = .00010;
			do_fog=true;

			cs_verts = 10;
			cs[0].x = 0;
			cs[0].y = 0;
			cs[0].z = 0;

			cs[1].x = 0;
			cs[1].y = piece_width;
			cs[1].z = 0;

			cs[2].x = 0;
			cs[2].y = piece_width+piece_width*.3;
			cs[2].z = piece_height/3;

			cs[3].x = 0;
			cs[3].y = piece_width+piece_width*.3;
			cs[3].z = piece_height*2/3;

			cs[4].x = 0;
			cs[4].y = piece_width+piece_width*.6;
			cs[4].z = piece_height;

			cs[5].x = 0;
			cs[5].y = piece_width;
			cs[5].z = piece_height*1.3;

			cs[6].x = 0;
			cs[6].y = 0;
			cs[6].z = piece_height*1.3;

			cs[7].x = 0;
			cs[7].y = -piece_width*.6;
			cs[7].z = piece_height;

			cs[8].x = 0;
			cs[8].y = -piece_width*.3;
			cs[8].z = piece_height*2/3;

			cs[9].x = 0;
			cs[9].y = -piece_width*.3;
			cs[9].z = piece_height/3;

			break;
		}
	case (SET_SPACE):
		{
			straight_length = 1500;
			turn_length = 500;
			sharp_turn_length = 1000;
			piece_width = 1000;
			piece_height = 1000;
			piece_width2 = piece_width/2;
			piece_height2 = piece_height/2;
			player_start.x = 0;
			player_start.y = piece_width/2;
			player_start.z = piece_height/2;
			noise = 0;
			noise_offset = 0;
			texture_number = 4;
			texture_list[0] = 4;
			texture_list[1] = 4;
			texture_list[2] = 4;
			texture_list[3] = 4;
			texture_list[4] = 4;
			texture_list[5] = 4;
			texture_list[6] = 4;
			texture_list[7] = 4;
			ship_diffuse[0] = .5;
			ship_diffuse[1] = .5;
			ship_diffuse[2] = .5;
			ship_diffuse[3] = 1;
			main_diffuse[0] = .3f;
			main_diffuse[1] = .3f;
			main_diffuse[2] = .3f;
			main_diffuse[3] = 1;
			cs_noises[0] = 0;
			cs_noises[1] = 0;
			cs_noises[2] = 0;
			cs_noises[3] = 0;
			cs_noises[4] = 0;
			cs_noises[5] = 0;
			cs_noises[6] = 0;
			cs_noises[7] = 0;
			cs_offsets[0] = 0;
			cs_offsets[1] = 0;
			cs_offsets[2] = 0;
			cs_offsets[3] = 0;
			cs_offsets[4] = 0;
			cs_offsets[5] = 0;
			cs_offsets[6] = 0;
			cs_offsets[7] = 0;
			fog_color[0] = 0;
			fog_color[1] = 0;
			fog_color[2] = 0;
			fog_density = .0001;
			do_fog=false;

			cs_verts = 8;
			cs[0].x = 0;
			cs[0].y = 0;
			cs[0].z = 0;
			
			cs[1].x = 0;
			cs[1].y = piece_width/2;
			cs[1].z = -piece_height/4;
			
			cs[2].x = 0;
			cs[2].y = piece_width;
			cs[2].z = 0;
			
			cs[3].x = 0;
			cs[3].y = piece_width + piece_width/4;
			cs[3].z = piece_height/2;
			
			cs[4].x = 0;
			cs[4].y = piece_width;
			cs[4].z = piece_height;
			
			cs[5].x = 0;
			cs[5].y = piece_width/2;
			cs[5].z = piece_height + piece_height/4;
			
			cs[6].x = 0;
			cs[6].y = 0;
			cs[6].z = piece_height;
			
			cs[7].x = 0;
			cs[7].y = -piece_width/4;
			cs[7].z = piece_height/2;
			
			

			break;
		}
	case (SET_METAL):
		{
			straight_length = 2000;
			turn_length = 200;
			sharp_turn_length = 400;
			piece_width = 700;
			piece_height = 1500;
			piece_width2 = piece_width/2;
			piece_height2 = piece_height/2;
			player_start.x = straight_length;
			player_start.y = piece_width/2;
			player_start.z = piece_height/2;
			noise = 0;
			noise_offset = 0;
			texture_number = 5;
			texture_list[0] = 5;
			texture_list[1] = 5;
			texture_list[2] = 5;
			texture_list[3] = 6;
			texture_list[4] = 5;
			texture_list[5] = 5;
			texture_list[6] = 5;
			texture_list[7] = 5;
			texture_list[8] = 5;
			texture_list[9] = 6;
			texture_list[10] = 5;
			texture_list[11] = 5;
			ship_diffuse[0] = .6f;
			ship_diffuse[1] = .3f;
			ship_diffuse[2] = 0;
			ship_diffuse[3] = 1;
			main_diffuse[0] = .6f;
			main_diffuse[1] = .3f;
			main_diffuse[2] = 0;
			main_diffuse[3] = 1;
			cs_noises[0] = 0;
			cs_noises[1] = 0;
			cs_noises[2] = 0;
			cs_noises[3] = 0;
			cs_noises[4] = 0;
			cs_noises[5] = 0;
			cs_noises[6] = 0;
			cs_noises[7] = 0;
			cs_noises[8] = 0;
			cs_noises[9] = 0;
			cs_noises[10] = 0;
			cs_noises[11] = 0;
			cs_offsets[0] = 0;
			cs_offsets[1] = 0;
			cs_offsets[2] = 0;
			cs_offsets[3] = 0;
			cs_offsets[4] = 0;
			cs_offsets[5] = 0;
			cs_offsets[6] = 0;
			cs_offsets[7] = 0;
			cs_offsets[8] = 0;
			cs_offsets[9] = 0;
			cs_offsets[10] = 0;
			cs_offsets[11] = 0;
			fog_color[0] = .3;
			fog_color[1] = .15;
			fog_color[2] = 0;
			fog_density = .0001;
			do_fog=true;

/*
			cs_verts = 8;
			cs[0].x = 0;
			cs[0].y = 0;
			cs[0].z = 0;
			
			cs[1].x = 0;
			cs[1].y = piece_width;
			cs[1].z = 0;

			cs[2].x = 0;
			cs[2].y = piece_width;
			cs[2].z = piece_height/3;

			cs[3].x = 0;
			cs[3].y = piece_width;
			cs[3].z = piece_height*2/3;

			cs[4].x = 0;
			cs[4].y = piece_width;
			cs[4].z = piece_height;

			cs[5].x = 0;
			cs[5].y = 0;
			cs[5].z = piece_height;

			cs[6].x = 0;
			cs[6].y = 0;
			cs[6].z = piece_height*2/3;

			cs[7].x = 0;
			cs[7].y = 0;
			cs[7].z = piece_height/3;
*/

			cs_verts = 12;
			cs[0].x = 0;
			cs[0].y = 0;
			cs[0].z = 0;
			
			cs[1].x = 0;
			cs[1].y = piece_width;
			cs[1].z = 0;

			cs[2].x = 0;
			cs[2].y = piece_width;
			cs[2].z = piece_height/3;

			cs[3].x = 0;
			cs[3].y = piece_width+40;
			cs[3].z = piece_height/3;

			cs[4].x = 0;
			cs[4].y = piece_width+40;
			cs[4].z = piece_height*2/3;

			cs[5].x = 0;
			cs[5].y = piece_width;
			cs[5].z = piece_height*2/3;

			cs[6].x = 0;
			cs[6].y = piece_width;
			cs[6].z = piece_height;

			cs[7].x = 0;
			cs[7].y = 0;
			cs[7].z = piece_height;

			cs[8].x = 0;
			cs[8].y = 0;
			cs[8].z = piece_height*2/3;

			cs[9].x = 0;
			cs[9].y = -40;
			cs[9].z = piece_height*2/3;

			cs[10].x = 0;
			cs[10].y = -40;
			cs[10].z = piece_height/3;

			cs[11].x = 0;
			cs[11].y = 0;
			cs[11].z = piece_height/3;


			break;
		}
	case (SET_CAVE):
		{
			straight_length = 2000;
			turn_length = 500;
			sharp_turn_length = 1000;
			piece_width = 1000;
			piece_height = 1500;
			piece_width2 = piece_width/2;
			piece_height2 = piece_height/2;
			player_start.x = 0;
			player_start.y = piece_width/2;
			player_start.z = piece_height/2;
			noise = 250;
			noise_offset = -125;
			texture_number = 0;
			texture_list[0] = 0;
			texture_list[1] = 0;
			texture_list[2] = 0;
			texture_list[3] = 0;
			texture_list[4] = 0;
			texture_list[5] = 0;
			texture_list[6] = 0;
			texture_list[7] = 0;
			ship_diffuse[0] = 1;
			ship_diffuse[1] = 1;
			ship_diffuse[2] = 1;
			ship_diffuse[3] = 1;
			main_diffuse[0] = .5f;
			main_diffuse[1] = .5f;
			main_diffuse[2] = .5f;
			main_diffuse[3] = 1;
			cs_noises[0] = 250;
			cs_noises[1] = 250;
			cs_noises[2] = 250;
			cs_noises[3] = 250;
			cs_noises[4] = 250;
			cs_noises[5] = 250;
			cs_noises[6] = 250;
			cs_noises[7] = 250;
			cs_offsets[0] = -125;
			cs_offsets[1] = -125;
			cs_offsets[2] = -125;
			cs_offsets[3] = -125;
			cs_offsets[4] = -125;
			cs_offsets[5] = -125;
			cs_offsets[6] = -125;
			cs_offsets[7] = -125;
			cs_offsets[0] = 0;
			cs_offsets[1] = 0;
			cs_offsets[2] = 0;
			cs_offsets[3] = 0;
			cs_offsets[4] = 0;
			cs_offsets[5] = 0;
			cs_offsets[6] = 0;
			cs_offsets[7] = 0;
			y_max_offset = 250;
			z_max_offset = 250;
			fog_color[0] = 0;
			fog_color[1] = 0;
			fog_color[2] = 0;
			fog_density = .00005;
			do_fog = true;

			cs_verts = 8;
			cs[0].x = 0;
			cs[0].y = 0;
			cs[0].z = 0;

			cs[1].x = 0;
			cs[1].y = piece_width;
			cs[1].z = 0;

			cs[2].x = 0;
			cs[2].y = piece_width+piece_width*.3;
			cs[2].z = piece_height/3;

			cs[3].x = 0;
			cs[3].y = piece_width+piece_width*.3;
			cs[3].z = piece_height*2/3;

			cs[4].x = 0;
			cs[4].y = piece_width;
			cs[4].z = piece_height;

			cs[5].x = 0;
			cs[5].y = 0;
			cs[5].z = piece_height;

			cs[6].x = 0;
			cs[6].y = -piece_width*.3;
			cs[6].z = piece_height*2/3;

			cs[7].x = 0;
			cs[7].y = -piece_width*.3;
			cs[7].z = piece_height/3;

			break;
		}
	}

	if (do_fog)
	{
		glClearColor(fog_color[0],fog_color[1],fog_color[2],fog_color[3]);
		glFogi(GL_FOG_MODE, fog_mode[fog_filter]);		// Fog Mode
		glFogfv(GL_FOG_COLOR, fog_color);			// Set Fog Color
		glFogf(GL_FOG_DENSITY, fog_density);				// How Dense Will The Fog Be
		glHint(GL_FOG_HINT, GL_NICEST);			// Fog Hint Value
		glFogf(GL_FOG_START, 1.0f);				// Fog Start Depth -as effective as a stump
		glFogf(GL_FOG_END, 5.0f);				// Fog End Depth
		glEnable(GL_FOG);					// Enables GL_FOG
	}
	else
	{
		glClearColor(0.0f, 0.0f, 0.0f, 0.5f);				// Black Background
		glDisable(GL_FOG);
	}


	//Background illumination
	glLightfv(GL_LIGHT0, GL_AMBIENT, main_diffuse);


	//Set lights to set's light setting
	glLightfv(GL_LIGHT1, GL_DIFFUSE, ship_diffuse);
	

//	glDisable(GL_LIGHT0);
//	glDisable(GL_LIGHT1);
	glDisable(GL_LIGHT2);
	glDisable(GL_LIGHT3);
	glDisable(GL_LIGHT4);
	glDisable(GL_LIGHT5);
	glDisable(GL_LIGHT6);
	glDisable(GL_LIGHT7);

	glLightfv(GL_LIGHT1, GL_AMBIENT, empty_light);
	glLightfv(GL_LIGHT2, GL_AMBIENT, empty_light);
	glLightfv(GL_LIGHT3, GL_AMBIENT, empty_light);
	glLightfv(GL_LIGHT4, GL_AMBIENT, empty_light);
	glLightfv(GL_LIGHT5, GL_AMBIENT, empty_light);
	glLightfv(GL_LIGHT6, GL_AMBIENT, empty_light);
	glLightfv(GL_LIGHT7, GL_AMBIENT, empty_light);

	glLightfv(GL_LIGHT1, GL_SPECULAR, empty_light);
	glLightfv(GL_LIGHT2, GL_SPECULAR, empty_light);
	glLightfv(GL_LIGHT3, GL_SPECULAR, empty_light);
	glLightfv(GL_LIGHT4, GL_SPECULAR, empty_light);
	glLightfv(GL_LIGHT5, GL_SPECULAR, empty_light);
	glLightfv(GL_LIGHT6, GL_SPECULAR, empty_light);
	glLightfv(GL_LIGHT7, GL_SPECULAR, empty_light);

	ship.pos.x=player_start.x;
	ship.pos.y=player_start.y;
	ship.pos.z=player_start.z;

	terrain.set_set(current_set);

	terrain_length=0;
	for (i=0; i<max_string_length; i++)
	{
		err_log << "reading " << i << " : " << terrain_string[i] << endl;
		//If end of string reached, break
		if (terrain_string[i]==0) break;

		turn_y = 0;
		turn_z = 0;
		if (terrain_string[i]=='(')
		{
			type = T_NORMAL;
			i++;
			turn_y_done = false;
			turn_z_done = false;
			while (terrain_string[i]!=')' && i<max_string_length)
			{
				err_log << "reading " << i << " : " << terrain_string[i] << endl;

				if (!turn_y_done && (terrain_string[i]=='l' || terrain_string[i]=='L'))
				{
					if (terrain_string[i]=='l')
						turn_y = sharp_turn_length;
					else
						turn_y = turn_length;
					turn_y_done = true;
					i++;
				}
				else if (!turn_y_done && (terrain_string[i]=='r' || terrain_string[i]=='R'))
				{
					if (terrain_string[i]=='r')
						turn_y = -sharp_turn_length;
					else
						turn_y = -turn_length;
					turn_y_done = true;
					i++;
				}
				else if (!turn_z_done && (terrain_string[i]=='d' || terrain_string[i]=='d'))
				{
					if (terrain_string[i]=='d')
						turn_z = -sharp_turn_length;
					else
						turn_z = -turn_length;
					turn_z_done = true;
					i++;
				}
				else if (!turn_z_done && (terrain_string[i]=='u' || terrain_string[i]=='U'))
				{
					if (terrain_string[i]=='u')
						turn_z = sharp_turn_length;
					else
						turn_z = turn_length;
					turn_z_done = true;
					i++;
				}
				else i++;
			}
			err_log << "reading " << i << " : " << terrain_string[i] << endl;

			if (i==max_string_length) err_log << "Unmatched closing parenthesis in string."<<endl;
		}
		else
		{
			switch (terrain_string[i])
			{
			case '{':
				{
					type = T_START;
					turn_y = 0;
					turn_z = 0;
					break;
				}
			case '}':
				{
					type = T_END;
					turn_y = 0;
					turn_z = 0;
					break;
				}
			case 'S':
				{
					type = T_NORMAL;
					turn_y = 0;
					turn_z = 0;

					break;
				}
			case 's':
				{
					type = T_NORMAL;
					turn_y = 0;
					turn_z = 0;

					break;
				}
			case 'l':
				{
					type = T_NORMAL;
					turn_y = turn_length;
					turn_z = 0;
					break;
				}
			case 'L':
				{
					type = T_NORMAL;
					turn_y = sharp_turn_length;
					turn_z = 0;
					break;
				}
			case 'r':
				{
					type = T_NORMAL;
					turn_y = -turn_length;
					turn_z = 0;
					break;
				}
			case 'R':
				{
					type = T_NORMAL;
					turn_y = -sharp_turn_length;
					turn_z = 0;
					break;
				}
			case 'd':
				{
					type = T_NORMAL;
					turn_y = 0;
					turn_z = -turn_length;;
					break;
				}
			case 'D':
				{
					type = T_NORMAL;
					turn_y = 0;
					turn_z = -sharp_turn_length;;
					break;
				}
			case 'u':
				{
					type = T_NORMAL;
					turn_y = 0;
					turn_z = turn_length;;
					break;
				}
			case 'U':
				{
					type = T_NORMAL;
					turn_y = 0;
					turn_z = sharp_turn_length;;
					break;
				}
			default:
				{
					err_log << "ERROR : Invalid symbol ["<<terrain_string[i]<<"] in terrain_string at ["<<i<<"]" << endl;
					break;
				}
			}
		}


		//If followed by '[', add monsters
		if (i+1<max_string_length && terrain_string[i+1]=='[')
		{
			i+=2;
			err_log << "PIECE LOC: ";
			err_log << location.x<<" " <<location.y<<" "<<location.z << endl;
			//Loop until end of monster definitions
			while (terrain_string[i]!=']')
			{
				monster_type = (int)terrain_string[i] - 48;
				monster_num = (int)terrain_string[i+1] - 48;
				err_log << "Monster_type: " << monster_type << endl;
				err_log << "Monster_num: " << monster_num << endl;

				for (j=0;j<monster_num;j++)
				{
					num_monsters++;

					if (num_monsters>max_num_monsters)
					{
						err_log << "Monsters in map exceeded!  "<<monster_num-j<<" monsters ignored."<<endl;
						break;
					}
					else
					{

					//Add monster_num monsters of type monster_type at piece_id==current_id
					monster_pos.x = rnd() * straight_length + location.x;
					y_max = location.y + ((double)(monster_pos.x-location.x)/(double)straight_length)*(double)turn_y;
					z_max = location.z + ((double)(monster_pos.x-location.x)/(double)straight_length)*(double)turn_z;
					y_min = y_max - piece_width;
					z_min = z_max - piece_height;

					y_max *=-1;
					z_max *=-1;

					//If mine, do not bound by padding
					if (monster_type!=0)
					{
						y_max -= y_max_offset;
						z_max -= z_max_offset;

						monster_pos.y = rnd() * (piece_width-y_max_offset*2) - y_max;
						monster_pos.z = rnd() * (piece_height-z_max_offset*2) - z_max;
					}
					else
					{
						monster_pos.y = rnd() * piece_width - y_max;
						monster_pos.z = rnd() * piece_height - z_max;
					}

					err_log << "["<<num_monsters<<"]New monster location: ";
					err_log << monster_pos.x<<" "<<monster_pos.y<<" "<<monster_pos.z<<endl;

/*
					if (num_monsters==1 || num_monsters==2)
					{
						monster_pos.y = y_max + rnd()*10;
						monster_pos.z = z_max + rnd()*10;
					}
*/
/*
					monster_pos.x = location.x;
					monster_pos.y = -y_max + rnd()*10;
					monster_pos.z = -z_max + rnd()*10;
*/
					monsters[current_monster_id].set_info(new_monster_id(),current_id,monster_type,monster_pos);

					}
				}
				i+=2;

				//Strip extra characters
				while (terrain_string[i]!=']' && ( ((int)terrain_string[i]<48) || ((int)terrain_string[i]>57) ) )
					i++;
			}
		}

		terrain_length++;

		terrain.add_piece(type, turn_y, turn_z, location, new_id());

		location.x += straight_length;
		location.y += turn_y;
		location.z += turn_z;
	}
	view_distance = (num_shown_terrain-1)*straight_length;
	err_log << "Terrain generated." << endl;

	err_log << "TERRAIN: " << terrain.get_node(0) << endl;

/*
	glLightfv(GL_LIGHT2, GL_POSITION, main_light_pos[2]);
	glLightfv(GL_LIGHT3, GL_POSITION, main_light_pos[3]);
	glLightfv(GL_LIGHT4, GL_POSITION, main_light_pos[4]);
	glLightfv(GL_LIGHT5, GL_POSITION, main_light_pos[5]);
	glLightfv(GL_LIGHT6, GL_POSITION, main_light_pos[6]);
	glLightfv(GL_LIGHT7, GL_POSITION, main_light_pos[7]);
*/


	err_log << "Num_monsters: "<<num_monsters << endl;

	err_log << "Set initialized." << endl;
}


void init_levels()
{
	current_level = 0;

	//Level 1 - Valley, easy
//	levels[0].level_string="{UD[01,11](Rd)[03,13,22](dl)[13,31,03,23]D(UR)[05,22](LU)[31,13]Du[31,41]DD[13,31,21]rRS[12]l(Lu)[08,23](lU)[44](lu)[02]u[11,01,21]S(RU)[32,11,21](LU)[11,21](rU)[31,41,11](RU)(d)[19](dl)[42,22]Uu[12,03]d[11,02,21]D(RD)[49,02](RU)[39,24](rU)}SSSSSSSSSSSSSSSSSSSSSSSSSS";
	levels[0].level_string="{SS[11]r[23,31]RS[22,11]u(Ul)[01](L)[02,11]S[22]d(ld)[06,21](Ld)[22,31]L[31]l[41,01]r[02,13](Ru)r[23,03]S[17]r[13]S[16,01]r[01]l[31,11]r[31,01,21,11]L[24]rLRL(uR}[42,21](uL)[02,11](UR)[04](Ul)[16]U[28]u[32]SSS[32,41]SSSS[19,02]d(RD)[08,24](RD)[02,15]DD[23,13]D[02]D[01,12]D[01,12]D[01,32,42]d[15,41]S[05]}dSdDDdDDDdSdDDDDDDDD";
	levels[0].set_number=SET_VALLEY;

	//Level 2 - Cave, easy
	levels[1].level_string="{UD[13](Rd)[13](dl)[13]D[13,02](UR)[08,12](LU)[33]D[41,11]u[03,22]D[25]D[25,12,01]r[01]R[02,12,41]S[42,02]l[31,41,12](Lu)[32,23](lU)[02](lu)uS[11](RU)[31](LU)[41,03,12](rU)[01](RU)[02,21](d)[24,12](dl)U[23,01]u[17]d[32,42]D[15,23,02](RD)[09](RU)[03,13](rU)[32,44]u}D(UR)d(dl)(DR)uU(UR)(UL)(Ul)USdDDDDDDD";
	levels[1].set_number=SET_CAVE;


	//Level 3 - Metal, easy
	levels[2].level_string="{S[41]u[42]RS[42]d[41]RSr[19]R[25,31]S[13,03]rl[02]R[03,13]d[12,32](dr)[32,41]d[01,14,41]r(RD)[42](Ru)[34]R[16](rd)[03,25,13]S[32,41]S[16]u[23,15]S[19]US[42]l[03](Ld)[05](LD)[09,11](lD)[04,41,31]d[42,32]D[31,15]d[15](LD)[32](lD)[24,12]D[32]dlL[03,14,32]l[02]S[03,12]r[09]R[03,13]r[07,12]S[09,09]l[13,01]LlS[04,19]u[19]U[15,25]u[29,31]U[35]S[12,03]S}SSr(RU)RdD(Dr)(DR)RRRRRRRRRRR";
	levels[2].set_number=SET_METAL;


	//Level 4 - Space, easy
	levels[3].level_string="{Su[15,23](ur)[15,32]r[15](dr)[23,11]d(ld)l[03,11](ul)[17]U[12,25](UR)[23,12]R[31](DR)[33,41,12]D[13,42](LD)[42,02]L[41](UL)U[41]rR[12]r[14]l[13]L[23,12]l[24]r[22]R[31,01]r[05](ur)[03](UR)[08](ur)[12](ld)[15,41](LD)[42](ld)(lU)[13](rD)[13,02](DL)(UR)[13](ur)[12,21](UR)[22]R[02](DR)[03,13]D[11](LD)L[11,41](UL)[32]U[32]S[31]S[41,02]R[11]L[21,11]R[14]L[14]RU[41,13]DU[22]D[22,01]R[11]L[13,31]D[33]R[01]L[02]D[02]R[02,12](UR)R[11](DR)D(LD)L[15](UL)[19,33]Uu[33]S[43]d[29]D[32,42,12,22]d[08]S}U(UR)R(DR)D(LD)L(UL)LLLLLLLLLLLL";
	levels[3].set_number=SET_SPACE;


	//No real need to populate these yet - for the current version, it will only have four levels
	//I will develop something to automatically populate a level with given parameters, since it is
	// really damn tedious to do it by hand, and doesn't seem to always look right.

/*
	//Level 5 - Valley, hard
	levels[4].level_string="{SrSlrRrS(ul)(uS)(ul)(uL)(ul)(uL)(ul)(uS)(ur)(uR)(DL)(dl)(Ld)(ld)dDdS(ur)R(UR)RU(ru)(lu)(RU)(rU)(RU)(rU)UuSS}SrRR(DR)(DR)(DR)DDDDDDDDDDDDD";
	levels[4].set_number=SET_VALLEY;

	//Level 6 - Cave, hard
	levels[5].level_string="{rd(rd)(Rd)d(rd)DDD(Dl)(DL)(Ld)LlSSr(rD)Du(UR)(DR)(UL)(Ur)rRS(dL)(dR)(dr)dDD(rd)(RD)(rd)dS}uU(Ur)(UR)(UR)(UR)(UR)(UR)(UR)(UR)(UR)(UR)(UR)(UR)(UR)(UR)(UR)(UR)(UR)(UR)";
	levels[5].set_number=SET_CAVE;

	//Level 7 - Metal, hard
	levels[6].level_string="{rRRr(ul)udr(lu)(uL)(ul)(UL)(Ul)uSSuSUSdDdSuU(RU)D(LU)DdrRR(Ru)(rU)U(Ul)(uL)LlSrR(RU)(rU)uSSSSSSS}SSSr(UR)(DR)RRRRRRRRRRRRRR";
	levels[6].set_number=SET_METAL;

	//Level 8 - Space, hard
	levels[7].level_string="{uUuSdDdSrR(ru)U(ul)L(ld)DdSruUuSdDd(Ru)(rU)ul(Ld)(lD)dDdS(ur)(UR)(ur)(dl)(DL)DdSrRru(RU)(DL)U(RD)LRLRuUlLlrRrlLrRlLRLRdDu(UR)(DL)(UL)(UR)(DR)(DL)(UL)RrSSSlLlSRLRLrlRLRLS}LRr(dr)(DR)(ur)RRUUUUUUUUUUUU";
	levels[7].set_number=SET_SPACE;
	
*/

	init_level(current_level);
	new_message("Welcome!",250);
	new_message("Entering level 1",300);
}

void init_level(int level_number)
{	
	current_level = level_number;

	current_set = levels[current_level].set_number;
	terrain_string = levels[current_level].level_string;

	generate_terrain();
}

void advance_level(int to_level)
{
	current_level = to_level-1;
	advance_level();
}

void advance_level()
{
	int i;

	temp_message = (char*)calloc(256,sizeof(char));

	current_level++;

	err_log << "Advancing to level " << current_level << endl;

	repulsion_mag = 0;
	SetCursorPos(SCREEN_X_MID,SCREEN_Y_MID);	

	if (current_level<num_levels)
	{
		//Continue to next level
		sprintf(temp_message,"Entering Level %i",current_level+1);
		new_message(temp_message,300);

		rebuild_walls = false;
		first_walls = true;
		walls_done = false;

		reset_player();

//		set_vars();

		delete walls1_model;
		walls1_model = newCollisionModel3D();
		delete walls2_model;
		walls2_model = newCollisionModel3D();

		for (i=0;i<max_shots;i++)
			shots[i].type=-1;

		for (i=0;i<max_num_monsters;i++)
			monsters[i].state=-1;

		for (i=0;i<max_num_explosions;i++)
			explosions[i].state=-1;

		current_id = 0;
		current_piece = 0;
		current_monster_id = 0;

		err_log << "About to initialize new level..."<<endl;

		init_level(current_level);
	}
	else
	{
		//No more levels - hence, you're teh b1g w1nn0|4
		new_message("You've won!  Congratulations!",400);
		new_message(" ",1000);
		new_message("Unpause to restart game.",400);
		won = true;
		paused=true;
	}
}

void reset_player()
{
	ship.reset();
}

void game_over()
{
	lives = starting_lives;
	score = 0;
	advance_level(0);
	advancing_level=true;
	new_message("Restarting game",200);
}


int new_id()
{
	return current_id++;
}

int new_monster_id()
{
	return current_monster_id++;
}

void new_message(char *c)
{
	messages.add_message(c);
}
void new_message(char *c, int max_life)
{
	messages.add_message(c, max_life);
}

double rnd()
{
	return ((double)rand()/(double)RAND_MAX);
}

void ship_hit(int damage)
{
	ship.shield_spin = shield_spin_max;

	ship.shield -= damage;
	if (ship.shield<=0)
	{
		if (!god_mode)
		{
			ship.armor += ship.shield;
		}
		ship.shield = 0;
	}
	if (ship.armor<=0 && !got_dead)
	{
		//Curtains for you
		new_message("You've been destroyed!",250);
		launch_explosion(ship.pos,ship.size,100,1);
		ship.armor=0;
		ship.state=0;
		err_log << "YOU DIED: ";
		err_log << ship.pos.x<<","<<ship.pos.y<<","<<ship.pos.z<<endl;

		lives--;
		got_dead = true;

		if (lives==0)
		{
			//Game over!
//			game_over();
			return;
		}
	}
}

void monster_hit(int id, int damage)
{
	monsters[id].health -= damage;
	monsters[id].shield_spin = shield_spin_max;

	if (monsters[id].health<=0)
	{
		//Kill monster
//		new_message("Killed a monster");
		score += monsters[id].score;
		launch_explosion(monsters[id].pos,monsters[id].size,monsters[id].explosive,0);
		monsters[id].state=-20;
	}
}



void set_vars()
{
//	num_boids=50;
//	draw_off=true;
	double box_size = ship_size;
	double box_size2 = box_size/2;
	int i;

	overall_time = 0;
	first_run = true;

	ship.shield = ship.shield_max;
	ship.armor = ship.armor_max;

	repulsion.x = 0;
	repulsion.y = 0;
	repulsion.z = 0;

	ship_base_offset.x = -100;
	ship_base_offset.y = 0;
	ship_base_offset.z = 0;
	ship_offset.x = ship_base_offset.x;
	ship_offset.y = ship_base_offset.y;
	ship_offset.z = ship_base_offset.z;


	bounding_box[0][0] = box_size;
	bounding_box[0][1] = box_size;
	bounding_box[0][2] = box_size;

	bounding_box[1][0] = box_size;
	bounding_box[1][1] = -box_size;
	bounding_box[1][2] = box_size;

	bounding_box[2][0] = -box_size;
	bounding_box[2][1] = -box_size;
	bounding_box[2][2] = box_size;

	bounding_box[3][0] = -box_size;
	bounding_box[3][1] = box_size;
	bounding_box[3][2] = box_size;

	bounding_box[4][0] = box_size;
	bounding_box[4][1] = box_size;
	bounding_box[4][2] = -box_size;

	bounding_box[5][0] = box_size;
	bounding_box[5][1] = -box_size;
	bounding_box[5][2] = -box_size;

	bounding_box[6][0] = -box_size;
	bounding_box[6][1] = -box_size;
	bounding_box[6][2] = -box_size;

	bounding_box[7][0] = -box_size;
	bounding_box[7][1] = box_size;
	bounding_box[7][2] = -box_size;

//	double theta, phi;
//	int x, y, z;

	time_total=0;
	time1=0;
	time2=0;

	i=0;
	//[0] Weak, fast
	shot_speeds[i] = 40;		//40
	shot_strengths[i] = 8;
	shot_size[i] = .2;
	shot_color[i][0] = 1;
	shot_color[i][1] = 1;
	shot_color[i][2] = 0;
	i++;

	//[1] Really weak, really fast
	shot_speeds[i] = 30;
	shot_strengths[i] = 8;
	shot_size[i] = .1;
	shot_color[i][0] = 1;
	shot_color[i][1] = 0;
	shot_color[i][2] = 1;
	i++;

	//[2] Strong, slow
	shot_speeds[i] = 30;	//30
	shot_strengths[i] = 15;
	shot_size[i] = .25;
	shot_color[i][0] = 1;
	shot_color[i][1] = 1;
	shot_color[i][2] = 1;
	i++;

	//[3] Strong, fast
	shot_speeds[i] = 20;
	shot_strengths[i] = 20;
	shot_size[i] = .2;
	shot_color[i][0] = 0;
	shot_color[i][1] = 1;
	shot_color[i][2] = 1;
	i++;

	//[4] Really strong, fast
	shot_speeds[i] = 30;
	shot_strengths[i] = 60;
	shot_size[i] = .25;
	shot_color[i][0] = 1;
	shot_color[i][1] = .5;
	shot_color[i][2] = 0;
	i++;




	light_ambient[0][0]=0;		//Background lighting
	light_ambient[0][1]=0;
	light_ambient[0][2]=0;
	light_ambient[0][3]=1;
	light_diffuse[0][0]=0;
	light_diffuse[0][1]=0;
	light_diffuse[0][2]=0;
	light_diffuse[0][3]=1;
	light_specular[0][0]=0;
	light_specular[0][1]=0;
	light_specular[0][2]=0;
	light_specular[0][3]=1;
	light_position[0][0]=0;
	light_position[0][1]=0;
	light_position[0][2]=0;
	light_position[0][3]=1;

	light_ambient[1][0]=1;		//Get rid of this
	light_ambient[1][1]=1;
	light_ambient[1][2]=1;
	light_ambient[1][3]=1;
	light_diffuse[1][0]=1;
	light_diffuse[1][1]=1;
	light_diffuse[1][2]=1;
	light_diffuse[1][3]=1;
	light_specular[1][0]=1;
	light_specular[1][1]=1;
	light_specular[1][2]=1;
	light_specular[1][3]=1;
	light_position[1][0]=0;
	light_position[1][1]=0;
	light_position[1][2]=0;
	light_position[1][3]=1;


	//Dark light values
	empty_light[0]=0;
	empty_light[1]=0;
	empty_light[2]=0;
	empty_light[3]=0;

	origin_light[0]=0;
	origin_light[1]=0;
	origin_light[2]=0;
	origin_light[3]=1;

	//Material values
	material_ambient[0][0]=1;	//RED
	material_ambient[0][1]=0;
	material_ambient[0][2]=0;
	material_ambient[0][3]=1;

	material_ambient[1][0]=0;	//GREEN
	material_ambient[1][1]=1;
	material_ambient[1][2]=0;
	material_ambient[1][3]=1;

	material_ambient[2][0]=0;	//BLUE
	material_ambient[2][1]=0;
	material_ambient[2][2]=1;
	material_ambient[2][3]=1;

	material_ambient[3][0]=1;	//YELLOW
	material_ambient[3][1]=1;
	material_ambient[3][2]=0;
	material_ambient[3][3]=1;

	material_ambient[4][0]=1;	//CYAN
	material_ambient[4][1]=0;
	material_ambient[4][2]=1;
	material_ambient[4][3]=1;

	material_ambient[5][0]=0;	//MAGENTA
	material_ambient[5][1]=1;
	material_ambient[5][2]=1;
	material_ambient[5][3]=1;

	material_ambient[6][0]=.5;	//DARK RED
	material_ambient[6][1]=0;
	material_ambient[6][2]=0;
	material_ambient[6][3]=1;

	material_ambient[7][0]=0;	//DARK GREEN
	material_ambient[7][1]=.5;
	material_ambient[7][2]=0;
	material_ambient[7][3]=1;

	material_ambient[8][0]=0;	//DARK BLUE
	material_ambient[8][1]=0;
	material_ambient[8][2]=.5;
	material_ambient[8][3]=1;

	material_ambient[9][0]=.5;	//DARK YELLOW
	material_ambient[9][1]=.5;
	material_ambient[9][2]=0;
	material_ambient[9][3]=1;

	material_ambient[10][0]=.5;	//DARK CYAN
	material_ambient[10][1]=0;
	material_ambient[10][2]=.5;
	material_ambient[10][3]=1;

	material_ambient[11][0]=0;	//DARK MAGENTA
	material_ambient[11][1]=.5;
	material_ambient[11][2]=.5;
	material_ambient[11][3]=1;

	material_ambient[12][0]=1;	//ORANGE
	material_ambient[12][1]=.5;
	material_ambient[12][2]=0;
	material_ambient[12][3]=1;

	material_ambient[13][0]=0;	//BLACK
	material_ambient[13][1]=0;
	material_ambient[13][2]=0;
	material_ambient[13][3]=1;

	material_ambient[14][0]=0;	//
	material_ambient[14][1]=1;
	material_ambient[14][2]=.5;
	material_ambient[14][3]=1;

	material_ambient[15][0]=.5;	//
	material_ambient[15][1]=1;
	material_ambient[15][2]=0;
	material_ambient[15][3]=1;

	material_ambient[16][0]=0;	//
	material_ambient[16][1]=.5;
	material_ambient[16][2]=1;
	material_ambient[16][3]=1;

	material_ambient[17][0]=.5;	//GREY
	material_ambient[17][1]=.5;
	material_ambient[17][2]=.5;
	material_ambient[17][3]=1;

	material_ambient[18][0]=.2f;	//DARK GREY
	material_ambient[18][1]=.2f;
	material_ambient[18][2]=.2f;
	material_ambient[18][3]=1;

	material_ambient[19][0]=1;	//WHITE
	material_ambient[19][1]=1;
	material_ambient[19][2]=1;
	material_ambient[19][3]=1;

	material_diffuse[0][0]=1;
	material_diffuse[0][1]=1;
	material_diffuse[0][2]=1;
	material_diffuse[0][3]=1;
	material_specular[0][0]=1;
	material_specular[0][1]=1;
	material_specular[0][2]=1;
	material_specular[0][3]=1;
	material_shininess[0]=.5;


	terrain.set_set(1);

/*
	ship_model->addTriangle(bounding_box[0],bounding_box[1],bounding_box[2]);
	ship_model->addTriangle(bounding_box[2],bounding_box[3],bounding_box[0]);

	ship_model->addTriangle(bounding_box[4],bounding_box[5],bounding_box[1]);
	ship_model->addTriangle(bounding_box[1],bounding_box[0],bounding_box[4]);

	ship_model->addTriangle(bounding_box[5],bounding_box[6],bounding_box[2]);
	ship_model->addTriangle(bounding_box[2],bounding_box[1],bounding_box[5]);

	ship_model->addTriangle(bounding_box[6],bounding_box[7],bounding_box[3]);
	ship_model->addTriangle(bounding_box[3],bounding_box[2],bounding_box[6]);

	ship_model->addTriangle(bounding_box[7],bounding_box[4],bounding_box[0]);
	ship_model->addTriangle(bounding_box[0],bounding_box[3],bounding_box[7]);

	ship_model->addTriangle(bounding_box[7],bounding_box[6],bounding_box[5]);
	ship_model->addTriangle(bounding_box[5],bounding_box[4],bounding_box[7]);
*/
	ship_model->addTriangle(box_size,0,0,
		-box_size,-box_size2,0,
		-box_size,box_size2,0);

	ship_model->addTriangle(box_size,0,0,
		-box_size,box_size2,0,
		-box_size,0,box_size2);

	ship_model->addTriangle(box_size,0,0,
		-box_size,0,box_size2,
		-box_size,-box_size2,0);

//	ship_model->sphereCollision(origin,ship_size);
	ship_model->finalize();


/*
	offset[T_STRAIGHT].x = straight_length;
	offset[T_STRAIGHT].y = 0;
	offset[T_STRAIGHT].z = 0;

	offset[T_LEFT].x = straight_length;
	offset[T_LEFT].y = -turn_length;
	offset[T_LEFT].z = 0;

	offset[T_RIGHT].x = straight_length;
	offset[T_RIGHT].y = turn_length;
	offset[T_RIGHT].z = 0;

	offset[T_S_LEFT].x = straight_length;
	offset[T_S_LEFT].y = -sharp_turn_length;
	offset[T_S_LEFT].z = 0;

	offset[T_S_RIGHT].x = straight_length;
	offset[T_S_RIGHT].y = sharp_turn_length;
	offset[T_S_RIGHT].z = 0;

	offset[T_START].x = straight_length;
	offset[T_START].y = 0;
	offset[T_START].z = 0;

	offset[T_END].x = straight_length;
	offset[T_END].y = 0;
	offset[T_END].z = 0;
*/

	for (i=0;i<max_shots;i++)
		shots[i].type=-1;

	for (i=0;i<max_num_explosions;i++)
		explosions[i].state=-1;

	binding[FIRE_1]=MOUSE_LEFT;
	binding[FIRE_2]=MOUSE_RIGHT;
	binding[ACC_PLUS]='E';
	binding[ACC_MINUS]='Q';
	binding[PAUSE]=VK_SPACE;
	binding[LEVEL_JUMP]='J';
	binding[GOD_MODE]='G';
	binding[STRAFE_L]='A';
	binding[STRAFE_R]='D';
	binding[STRAFE_U]='W';
	binding[STRAFE_D]='S';


//	binding[MOVE_FORWARD]=MOUSE_LEFT;
//	binding[MOVE_BACKWARD]=VK_CONTROL;
//	binding[LOOK_LEFT]=VK_LEFT;
//	binding[LOOK_RIGHT]=VK_RIGHT;
//	binding[MOVE_LEFT]='S';
//	binding[MOVE_RIGHT]='D';
//	binding[JUMP]='A';
//	binding[DUCK]='Z';

}
