//message.cpp

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>

#include "message.h"

const int message_max = 512;

const int default_max_life = 100;

message::message()
{
	head=NULL;
}


void message::add_message(char *c)
{
	this->add_message(c, default_max_life);
}

void message::add_message(char *c, int max_life)
{
	int i;
	message_node *current = head;

	if (current == NULL)
	{
		//Add first

		current = new message_node;
		current->c = (char*)calloc(message_max,sizeof(char));

		i=0;
		while (c[i]!=0 && i<message_max)
		{
			current->c[i] = c[i];
			i++;
		}
		current->life = 0;
		current->max_life = max_life;
		current->next = NULL;
		current->prev = NULL;

		head = current;
	}
	else
	{
		//Add to end

		while (current->next!=NULL)
			current=current->next;

		current->next = new message_node;
		current->next->c = (char*)calloc(message_max,sizeof(char));

		current->next->prev = current;
		current = current->next;
		current->next = NULL;
		current->life = 0;
		current->max_life = max_life;

		i=0;
		while (c[i]!=0 && i<message_max)
		{
			current->c[i] = c[i];
			i++;
		}
	}
}


void message::drop_message()
{
	message_node *current = head;

	if (current!=NULL)
	{
		head = current->next;
		head->prev = NULL;
		delete current;
	}
}

char *message::get_message(int id)
{
	int i;
	message_node *current = head;

	i=0;
	while (current!=NULL && i!=id)
	{
		current=current->next;
		i++;
	}

	if (current!=NULL)
		return current->c;
	else
		return NULL;
}

void message::remove_node(message_node *current)
{
	if (current==NULL)
		return;

	if (current->next==NULL && head==current)
	{
		//Removing first and only item
		delete current;
		head = NULL;
		return;
	}
	else if (current->next==NULL)
	{
		//Removing last
		current->prev->next = NULL;
		current->next = NULL;
		current->prev = NULL;
		delete current;
		return;
	}
	else if (current==head)
	{
		//Removing first
		current->next->prev = NULL;
		head = current->next;
		current->next = NULL;
		delete current;
		return;
	}
	else
	{
		//Remove other
		current->next->prev = current->prev;
		current->prev->next = current->next;
		current->next = NULL;
		current->prev = NULL;
		delete current;
		return;
	}
}

void message::age_messages(float time_factor)
{
	message_node *current = head;
	message_node *skip;

	if (current == NULL)
		return;
	else
	{
		while (current!=NULL)
		{
			current->life+=time_factor;
			if (current->life >= current->max_life)
			{
				skip = current->next;
				remove_node(current);
				current = skip;
			}
			else
				current=current->next;
		}
	}
}
