//monster.cpp

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "monster.h"
#include "XYZ.h";
#include "shot.h"

//Monster types:
#define M_MINE		0
#define M_PEON		1
#define M_KAMI		2
#define M_TANK1		3
#define M_TANK2		4


monster::monster()
{
	id = -1;
	piece_id = -1;
	pos.x = 0;
	pos.y = 0;
	pos.z = 0;
	vel.x = 0;
	vel.y = 0;
	vel.z = 0;
	theta = 0;
	phi = 0;
	type = -1;
	speed = 0;
	health = 1;
	shot_type = -1;
	shot_delay = 1;
	shot_wait = 0;
	trigger_distance = 0;
	mass = 1;
	state = -1;
	explosive = 0;
	model = 0;
	life = 0;
	score = 0;
	accuracy = 0;
}

void monster::set_info(int new_id,int new_piece_id,int new_type,XYZ new_pos)
{
	id = new_id;
	state = 0;
	type = new_type;
	piece_id = new_piece_id;

	pos.x = new_pos.x;
	pos.y = new_pos.y;
	pos.z = new_pos.z;
	vel.x = 0;
	vel.y = 0;
	vel.z = 0;
	theta = 180;
	phi = 0;
	goal.x = -1;
	goal.y = -1;
	goal.z = -1;
	shield_spin = 0;
	life = 0;

	accuracy = 0;

	shot_wait = 0;

	switch (type)
	{
	case M_MINE:
		{
			speed = 0;
			health = 50;
			shot_type = -1;
			shot_delay = 0;
			trigger_distance = 1000;
			mass = 40;
			explosive = 75;
			size = 150;
			scale = 1;
			model = 1;
			score = 5;
			break;
		}
	case M_PEON:
		{
			speed = 8;
			health = 10;
			shot_type = 1;
			shot_delay = 40;
			trigger_distance = 6000;
			mass = 20;
			explosive = 0;
			size = 150;
			scale = 6;
			model = 2;
			score = 25;
			break;
		}
	case M_KAMI:
		{
			speed = 8;
			health = 10;
			shot_type = -1;
			shot_delay = 0;
			trigger_distance = 6000;
			mass = 35;
			explosive = 0;
			size = 150;
			scale = 6;
			model = 2;
			score = 25;
			break;
		}
	case M_TANK1:
		{
			speed = 5;
			health = 50;
			shot_type = 3;
			shot_delay = 80;
			trigger_distance = 6000;
			mass = 65;
			explosive = 15;
			size = 200;
			scale = 3;
			model = 3;
			score = 125;
			break;
		}
	case M_TANK2:
		{
			speed = 10;
			health = 40;
			shot_type = 1;
			shot_delay = 10;
			trigger_distance = 6000;
			mass = 55;
			explosive = 0;
			size = 200;
			scale = 3;
			model = 3;
			score = 100;
			accuracy = 500;
			break;
		}
	}

	sizeS = size*size;
	accuracy2 = accuracy/2;
		
}