//terrain.cpp

#include "terrain_list.h"
#include <stdio.h>
#include <stdlib.h>
#include <fstream.h>
#include <math.h>



terrain_list::terrain_list()
{
	head=NULL;
}

terrain_list::terrain_list(int new_set)
{
	head=NULL;
	set = new_set;
}


void terrain_list::add_piece(int type, double turn_y, double turn_z, XYZ translate, int id)
{
	terrain_node *current = head;

	if (current==NULL)
	{
		//List is empty -> add first item
		current = new terrain_node;
		head=current;

		current->next=NULL;
		current->prev=NULL;
	}
	else
	{
		//List is non-empty -> find last element
		while (current->next!=NULL) current=current->next;

		//Add item after last element
		current->next = new terrain_node;
		current->next->prev = current;
		current = current->next;
		current->next = NULL;
		
	}

	current->translate.x = translate.x;
	current->translate.y = translate.y;
	current->translate.z = translate.z;
	current->turn_y = turn_y;
	current->turn_z = turn_z;
	current->id = id;
	current->type = type;
}


terrain_node *terrain_list::get_node(int id)
{
	terrain_node *current = head;

	while (current!=NULL)
	{
		if (current->id==id)
		{
			return current;
		}
		current=current->next;
	}
	return NULL;
}

int terrain_list::get_set()
{
	return set;
}

void terrain_list::set_set(int new_set)
{
	set = new_set;
}

void terrain_list::clear_terrain()
{
	terrain_node *current = head;
	terrain_node *rem_node;

	while (current!=NULL)
	{
		if (current->next!=NULL)
		{
			rem_node = current;
			current=current->next;
			current->prev = NULL;

			rem_node->prev = NULL;
			rem_node->next = NULL;
			delete rem_node;
		}
		else
		{
			delete current;
			break;
		}
	}
	head = NULL;
}