//terrain_list.h

#include "XYZ.h"

struct terrain_node
{
	int type;			//Piece type (start, end, etc.)
	double turn_y;		//Curve Y amount (left,right)
	double turn_z;		//Curve Z amount (down,up)
	XYZ translate;		//Translation of corner point
	int id;				//Unique id

	terrain_node *next;
	terrain_node *prev;
};


class terrain_list
{
public:
	terrain_list();
	terrain_list(int new_set);


	void add_piece(int type, double turn_y, double turn_z, XYZ translate, int id);
	void clear_terrain();

	terrain_node *get_node(int id);
	int get_set();
	void set_set(int new_set);


private:
	terrain_node *head;
	int set;				//Set - Valley, metal, space, etc.
};